(self.webpackChunkRemoteClient = self.webpackChunkRemoteClient || []).push([
  [3770],
  {
    62162: (e, t, r) => {
      'use strict';
      r.d(t, { P: () => g });
      var n = r(29768),
        i = r(88762),
        s = r(82058),
        l = r(41864),
        o = r(60991),
        a = r(92143),
        c = r(76506),
        u = r(50406),
        p = r(32101),
        d = r(34250),
        f = (r(91306), r(97714)),
        b = r(17533),
        m = r(2906),
        h = r(49900),
        w = r(56420),
        v = r(74653);
      const y = a.L.getLogger('esri.layers.mixins.PortalLayer'),
        g = (e) => {
          let t = class extends e {
            constructor() {
              super(...arguments),
                (this.resourceReferences = { portalItem: null, paths: [] }),
                (this.userHasEditingPrivileges = !0);
            }
            destroy() {
              var e;
              null == (e = this.portalItem) || e.destroy(), (this.portalItem = null);
            }
            set portalItem(e) {
              e !== this._get('portalItem') &&
                (this.removeOrigin('portal-item'), this._set('portalItem', e));
            }
            readPortalItem(e, t, r) {
              if (t.itemId) return new w.default({ id: t.itemId, portal: r && r.portal });
            }
            writePortalItem(e, t) {
              e && e.id && (t.itemId = e.id);
            }
            async loadFromPortal(e, t) {
              if (this.portalItem && this.portalItem.id)
                try {
                  const n = await r
                    .e(8642)
                    .then(r.bind(r, 8642))
                    .then(function (e) {
                      return e.l;
                    });
                  return (
                    (0, u.k_)(t),
                    await n.load(
                      {
                        instance: this,
                        supportedTypes: e.supportedTypes,
                        validateItem: e.validateItem,
                        supportsData: e.supportsData,
                      },
                      t,
                    )
                  );
                } catch (e) {
                  throw (
                    ((0, u.D_)(e) ||
                      y.warn(
                        `Failed to load layer (${this.title}, ${this.id}) portal item (${this.portalItem.id})\n  ${e}`,
                      ),
                    e)
                  );
                }
            }
            async finishLoadEditablePortalLayer(e) {
              this._set(
                'userHasEditingPrivileges',
                await this.fetchUserHasEditingPrivileges(e).catch((e) => ((0, u.r9)(e), !0)),
              );
            }
            async fetchUserHasEditingPrivileges(e) {
              const t = this.url ? (null == i.id ? void 0 : i.id.findCredential(this.url)) : null;
              if (!t) return !0;
              const r = x.credential === t ? x.user : await this.fetchEditingUser(e);
              return (
                (x.credential = t),
                (x.user = r),
                (0, c.b)(r) || null == r.privileges || r.privileges.includes('features:user:edit')
              );
            }
            async fetchEditingUser(e) {
              var t, r;
              const n = null == (t = this.portalItem) || null == (r = t.portal) ? void 0 : r.user;
              if (n) return n;
              const o = i.id.findServerInfo(this.url);
              if (null == o || !o.owningSystemUrl) return null;
              const a = `${o.owningSystemUrl}/sharing/rest`,
                u = h.Z.getDefault();
              if (u && u.loaded && (0, p.Fv)(u.restUrl) === (0, p.Fv)(a)) return u.user;
              const d = `${a}/community/self`,
                f = (0, c.i)(e) ? e.signal : null,
                b = await (0, l.r)(
                  (0, s.default)(d, { authMode: 'no-prompt', query: { f: 'json' }, signal: f }),
                );
              return b.ok ? v.default.fromJSON(b.value.data) : null;
            }
            read(e, t) {
              t && (t.layer = this), super.read(e, t);
            }
            write(e, t) {
              const r = t && t.portal,
                n =
                  this.portalItem &&
                  this.portalItem.id &&
                  (this.portalItem.portal || h.Z.getDefault());
              return r && n && !(0, p.tm)(n.restUrl, r.restUrl)
                ? (t.messages &&
                    t.messages.push(
                      new o.Z(
                        'layer:cross-portal',
                        `The layer '${this.title} (${this.id})' cannot be persisted because it refers to an item on a different portal than the one being saved to. To save the scene, set the layer.portalItem to null or save the scene to the same portal as the item associated with the layer`,
                        { layer: this },
                      ),
                    ),
                  null)
                : super.write(e, { ...t, layer: this });
            }
          };
          return (
            (0, n._)([(0, d.Cb)({ type: w.default })], t.prototype, 'portalItem', null),
            (0, n._)(
              [(0, f.r)('web-document', 'portalItem', ['itemId'])],
              t.prototype,
              'readPortalItem',
              null,
            ),
            (0, n._)(
              [(0, m.w)('web-document', 'portalItem', { itemId: { type: String } })],
              t.prototype,
              'writePortalItem',
              null,
            ),
            (0, n._)([(0, d.Cb)()], t.prototype, 'resourceReferences', void 0),
            (0, n._)(
              [(0, d.Cb)({ readOnly: !0 })],
              t.prototype,
              'userHasEditingPrivileges',
              void 0,
            ),
            (t = (0, n._)([(0, b.j)('esri.layers.mixins.PortalLayer')], t)),
            t
          );
        },
        x = { credential: null, user: null };
    },
    30439: (e, t, r) => {
      'use strict';
      r.d(t, { a: () => p, b: () => c, d: () => a, e: () => u }), r(76506);
      var n = r(5909),
        i = r(78548),
        s = r(60669),
        l = r(48208),
        o = r(6941);
      s.Z.fromJSON(o.d), i.Z.fromJSON(o.a), n.Z.fromJSON(o.b);
      const a = l.Z.fromJSON(o.c),
        c = s.Z.fromJSON(o.e),
        u = i.Z.fromJSON(o.f),
        p = n.Z.fromJSON(o.g);
    },
    50203: (e, t, r) => {
      'use strict';
      r.d(t, { a: () => c, b: () => u, c: () => d, d: () => p, g: () => w, t: () => a });
      var n = r(40642);
      const i = new RegExp('__begin__', 'ig'),
        s = new RegExp('__end__', 'ig'),
        l = new RegExp('^__begin__', 'i'),
        o = new RegExp('__end__$', 'i');
      function a(e) {
        return e.replace(new RegExp('\\{', 'g'), '[').replace(new RegExp('\\}', 'g'), ']');
      }
      function c(e) {
        const t = { expression: '', type: 'none' };
        return (
          e.labelExpressionInfo
            ? e.labelExpressionInfo.value
              ? ((t.expression = e.labelExpressionInfo.value), (t.type = 'conventional'))
              : e.labelExpressionInfo.expression &&
                ((t.expression = e.labelExpressionInfo.expression), (t.type = 'arcade'))
            : null != e.labelExpression &&
              ((t.expression = e.labelExpression
                .replace(new RegExp('\\[', 'g'), '{')
                .replace(new RegExp('\\]', 'g'), '}')),
              (t.type = 'conventional')),
          t
        );
      }
      function u(e) {
        const t = c(e);
        if (!t) return null;
        switch (t.type) {
          case 'conventional':
            return d(t.expression);
          case 'arcade':
            return t.expression;
        }
        return null;
      }
      function p(e) {
        const t = c(e);
        if (!t) return null;
        switch (t.type) {
          case 'conventional':
            return (function (e) {
              const t = e.match(f);
              return (t && t[1].trim()) || null;
            })(t.expression);
          case 'arcade':
            return w(t.expression);
        }
        return null;
      }
      function d(e) {
        let t;
        return (
          e
            ? ((t = (0, n.r)(e, (e) => '__begin__$feature["' + e + '"]__end__')),
              (t = l.test(t) ? t.replace(l, '') : '"' + t),
              (t = o.test(t) ? t.replace(o, '') : t + '"'),
              (t = t.replace(i, '" + ').replace(s, ' + "')))
            : (t = '""'),
          t
        );
      }
      const f = /^\s*\{([^}]+)\}\s*$/i,
        b = /^\s*(?:(?:\$feature\.(\w+))|(?:\$feature\[(["'])([\w\s]+)(\2)\]));?\s*$/i,
        m = /^\s*(?:(?:\$feature\.(\w+))|(?:\$feature\[(["'])([\w\s]+)(\2)\]));?\s*(?:DomainName\(\s*\$feature\s*,\s*(["'])(\1|\3)(\5)\s*\));?\s*$/i,
        h = /^\s*(?:DomainName\(\s*\$feature\s*,\s*(["'])([\w\s]+)(\1)\s*\));?\s*$/i;
      function w(e) {
        if (!e) return null;
        let t = b.exec(e) || m.exec(e);
        return t ? t[1] || t[3] : ((t = h.exec(e)), t ? t[2] : null);
      }
    },
    77807: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => E });
      var n,
        i = r(29768),
        s = r(96467),
        l = r(57251),
        o = r(74673),
        a = r(76506),
        c = r(34250),
        u = (r(91306), r(92143), r(97714)),
        p = r(17533),
        d = r(2906),
        f = r(50203),
        b = r(30439),
        m = r(16218);
      r(63571),
        r(40642),
        r(71552),
        r(59465),
        r(14249),
        r(60991),
        r(81172),
        r(31450),
        r(9801),
        r(53523),
        r(42911),
        r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(26341),
        r(46826),
        r(45433),
        r(60217),
        r(74569),
        r(21801),
        r(73796),
        r(60947),
        r(91597),
        r(86787),
        r(35132),
        r(89623),
        r(84069),
        r(44567),
        r(98380),
        r(92896),
        r(22781),
        r(32422),
        r(30776),
        r(48027),
        r(54174),
        r(82426),
        r(63130),
        r(25696),
        r(66396),
        r(42775),
        r(95834),
        r(34394),
        r(57150),
        r(76726),
        r(20444),
        r(76393),
        r(78548),
        r(2497),
        r(49906),
        r(46527),
        r(48649),
        r(9960),
        r(3101),
        r(5853),
        r(39141),
        r(32101),
        r(38742),
        r(48243),
        r(15324),
        r(76996),
        r(34635),
        r(10401),
        r(49900),
        r(66284),
        r(33921),
        r(3482),
        r(82058),
        r(88762),
        r(73173),
        r(22739),
        r(20543),
        r(67477),
        r(78533),
        r(74653),
        r(91091),
        r(58943),
        r(70737),
        r(8487),
        r(17817),
        r(90814),
        r(15459),
        r(61847),
        r(16796),
        r(16955),
        r(22401),
        r(77894),
        r(55187),
        r(8586),
        r(44509),
        r(69814),
        r(11305),
        r(62259),
        r(44790),
        r(5909),
        r(60669),
        r(48208),
        r(51589),
        r(6941),
        r(9075);
      let h = (n = class extends o.a {
        constructor() {
          super(...arguments), (this.expression = null), (this.title = null), (this.value = null);
        }
        readExpression(e, t) {
          return t.value ? (0, f.c)(t.value) : e;
        }
        writeExpression(e, t, r) {
          null != this.value && (e = (0, f.c)(this.value)), (t[r] = e);
        }
        clone() {
          return new n({ expression: this.expression, title: this.title, value: this.value });
        }
      });
      (0, i._)(
        [(0, c.Cb)({ type: String, json: { write: { allowNull: !0 } } })],
        h.prototype,
        'expression',
        void 0,
      ),
        (0, i._)(
          [(0, u.r)('expression', ['expression', 'value'])],
          h.prototype,
          'readExpression',
          null,
        ),
        (0, i._)([(0, d.w)('expression')], h.prototype, 'writeExpression', null),
        (0, i._)(
          [
            (0, c.Cb)({
              type: String,
              json: { write: !0, origins: { 'web-scene': { write: !1 } } },
            }),
          ],
          h.prototype,
          'title',
          void 0,
        ),
        (0, i._)([(0, c.Cb)({ json: { read: !1, write: !1 } })], h.prototype, 'value', void 0),
        (h = n = (0, i._)([(0, p.j)('esri.layers.support.LabelExpressionInfo')], h));
      var w,
        v = h;
      const y = new l.J(
        {
          esriServerPointLabelPlacementAboveCenter: 'above-center',
          esriServerPointLabelPlacementAboveLeft: 'above-left',
          esriServerPointLabelPlacementAboveRight: 'above-right',
          esriServerPointLabelPlacementBelowCenter: 'below-center',
          esriServerPointLabelPlacementBelowLeft: 'below-left',
          esriServerPointLabelPlacementBelowRight: 'below-right',
          esriServerPointLabelPlacementCenterCenter: 'center-center',
          esriServerPointLabelPlacementCenterLeft: 'center-left',
          esriServerPointLabelPlacementCenterRight: 'center-right',
          esriServerLinePlacementAboveAfter: 'above-after',
          esriServerLinePlacementAboveAlong: 'above-along',
          esriServerLinePlacementAboveBefore: 'above-before',
          esriServerLinePlacementAboveStart: 'above-start',
          esriServerLinePlacementAboveEnd: 'above-end',
          esriServerLinePlacementBelowAfter: 'below-after',
          esriServerLinePlacementBelowAlong: 'below-along',
          esriServerLinePlacementBelowBefore: 'below-before',
          esriServerLinePlacementBelowStart: 'below-start',
          esriServerLinePlacementBelowEnd: 'below-end',
          esriServerLinePlacementCenterAfter: 'center-after',
          esriServerLinePlacementCenterAlong: 'center-along',
          esriServerLinePlacementCenterBefore: 'center-before',
          esriServerLinePlacementCenterStart: 'center-start',
          esriServerLinePlacementCenterEnd: 'center-end',
          esriServerPolygonPlacementAlwaysHorizontal: 'always-horizontal',
        },
        { ignoreUnknown: !0 },
      );
      function g(e) {
        return !e || ('service' !== e.origin && !x(e.layer));
      }
      function x(e) {
        return 'map-image' === (null == e ? void 0 : e.type);
      }
      function S(e) {
        var t, r;
        return (
          !!x(e) &&
          !(
            null == (t = e.capabilities) ||
            null == (r = t.exportMap) ||
            !r.supportsArcadeExpressionForLabeling
          )
        );
      }
      let _ = (w = class extends o.a {
        constructor(e) {
          super(e),
            (this.type = 'label'),
            (this.name = null),
            (this.deconflictionStrategy = 'static'),
            (this.labelExpression = null),
            (this.labelExpressionInfo = null),
            (this.labelPlacement = null),
            (this.maxScale = 0),
            (this.minScale = 0),
            (this.symbol = b.d),
            (this.useCodedValues = void 0),
            (this.where = null);
        }
        static evaluateWhere(e, t) {
          const r = function (e, t, r) {
            switch (t) {
              case '=':
                return e == r;
              case '<>':
                return e != r;
              case '>':
                return e > r;
              case '>=':
                return e >= r;
              case '<':
                return e < r;
              case '<=':
                return e <= r;
            }
            return !1;
          };
          try {
            if (null == e) return !0;
            const n = e.split(' ');
            if (3 === n.length) return r(t[n[0]], n[1], n[2]);
            if (7 === n.length) {
              const e = r(t[n[0]], n[1], n[2]),
                i = n[3],
                s = r(t[n[4]], n[5], n[6]);
              switch (i) {
                case 'AND':
                  return e && s;
                case 'OR':
                  return e || s;
              }
            }
            return !1;
          } catch (t) {
            console.log("Error.: can't parse = " + e);
          }
        }
        readLabelExpression(e, t) {
          const r = t.labelExpressionInfo;
          if (!r || (!r.value && !r.expression)) return e;
        }
        writeLabelExpression(e, t, r) {
          if (this.labelExpressionInfo)
            if (null != this.labelExpressionInfo.value)
              e = (0, f.t)(this.labelExpressionInfo.value);
            else if (null != this.labelExpressionInfo.expression) {
              const t = (0, f.g)(this.labelExpressionInfo.expression);
              t && (e = '[' + t + ']');
            }
          null != e && (t[r] = e);
        }
        writeLabelExpressionInfo(e, t, r, n) {
          if (null == e && null != this.labelExpression && g(n))
            e = new v({ expression: this.getLabelExpressionArcade() });
          else if (!e) return;
          const i = e.toJSON(n);
          i.expression && (t[r] = i);
        }
        writeMaxScale(e, t) {
          (e || this.minScale) && (t.maxScale = e);
        }
        writeMinScale(e, t) {
          (e || this.maxScale) && (t.minScale = e);
        }
        getLabelExpression() {
          return (0, f.a)(this);
        }
        getLabelExpressionArcade() {
          return (0, f.b)(this);
        }
        getLabelExpressionSingleField() {
          return (0, f.d)(this);
        }
        hash() {
          return JSON.stringify(this);
        }
        clone() {
          return new w({
            deconflictionStrategy: this.deconflictionStrategy,
            labelExpression: this.labelExpression,
            labelExpressionInfo: (0, a.d9)(this.labelExpressionInfo),
            labelPlacement: this.labelPlacement,
            maxScale: this.maxScale,
            minScale: this.minScale,
            name: this.name,
            symbol: (0, a.d9)(this.symbol),
            where: this.where,
            useCodedValues: this.useCodedValues,
          });
        }
      });
      (0, i._)([(0, c.Cb)({ type: String, json: { write: !0 } })], _.prototype, 'name', void 0),
        (0, i._)(
          [
            (0, c.Cb)({
              type: String,
              json: { write: !0, default: 'static', origins: { 'web-scene': { write: !1 } } },
            }),
          ],
          _.prototype,
          'deconflictionStrategy',
          void 0,
        ),
        (0, i._)(
          [
            (0, c.Cb)({
              type: String,
              json: {
                write: {
                  overridePolicy(e, t, r) {
                    return this.labelExpressionInfo &&
                      'service' === (null == r ? void 0 : r.origin) &&
                      S(r.layer)
                      ? { enabled: !1 }
                      : { allowNull: !0 };
                  },
                },
              },
            }),
          ],
          _.prototype,
          'labelExpression',
          void 0,
        ),
        (0, i._)([(0, u.r)('labelExpression')], _.prototype, 'readLabelExpression', null),
        (0, i._)([(0, d.w)('labelExpression')], _.prototype, 'writeLabelExpression', null),
        (0, i._)(
          [
            (0, c.Cb)({
              type: v,
              json: {
                write: {
                  overridePolicy: (e, t, r) =>
                    (function (e) {
                      return g(e) || S(e.layer);
                    })(r)
                      ? { allowNull: !0 }
                      : { enabled: !1 },
                },
              },
            }),
          ],
          _.prototype,
          'labelExpressionInfo',
          void 0,
        ),
        (0, i._)([(0, d.w)('labelExpressionInfo')], _.prototype, 'writeLabelExpressionInfo', null),
        (0, i._)(
          [
            (0, c.Cb)({
              type: y.apiValues,
              json: { type: y.jsonValues, read: y.read, write: y.write },
            }),
          ],
          _.prototype,
          'labelPlacement',
          void 0,
        ),
        (0, i._)([(0, c.Cb)({ type: Number })], _.prototype, 'maxScale', void 0),
        (0, i._)([(0, d.w)('maxScale')], _.prototype, 'writeMaxScale', null),
        (0, i._)([(0, c.Cb)({ type: Number })], _.prototype, 'minScale', void 0),
        (0, i._)([(0, d.w)('minScale')], _.prototype, 'writeMinScale', null),
        (0, i._)(
          [
            (0, c.Cb)({
              types: s.yK,
              json: {
                origins: { 'web-scene': { types: s.S6, write: m.c, default: null } },
                write: m.c,
                default: null,
              },
            }),
          ],
          _.prototype,
          'symbol',
          void 0,
        ),
        (0, i._)(
          [(0, c.Cb)({ type: Boolean, json: { write: !0 } })],
          _.prototype,
          'useCodedValues',
          void 0,
        ),
        (0, i._)([(0, c.Cb)({ type: String, json: { write: !0 } })], _.prototype, 'where', void 0),
        (_ = w = (0, i._)([(0, p.j)('esri.layers.support.LabelClass')], _));
      const E = _;
    },
    78893: (e, t, r) => {
      'use strict';
      r.d(t, { eZ: () => p });
      var n = r(86748),
        i = r(14249),
        s = r(30574),
        l = (r(2157), r(25977), r(7471)),
        o = (r(45154), r(4292), r(54414)),
        a = r(1648);
      r(15324),
        r(91055),
        r(76996),
        r(21972),
        r(23639),
        r(76506),
        r(92143),
        r(31450),
        r(71552),
        r(40642),
        r(34250),
        r(91306),
        r(86656),
        r(22723),
        r(17533),
        r(81172),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(74673),
        r(26341),
        r(86787),
        r(97714),
        r(2906),
        r(29107),
        r(57251),
        r(59465),
        r(8925),
        r(33921),
        r(3482),
        r(16769),
        r(55531),
        r(30582),
        r(593),
        r(85699),
        r(63136),
        r(96055),
        r(47776),
        r(18033),
        r(6331),
        r(62048),
        r(75626),
        r(72652),
        r(29641),
        r(30493),
        r(70821),
        r(82673),
        r(34229),
        r(37029),
        r(9801),
        r(53523),
        r(42911),
        r(46826),
        r(45433),
        r(60217),
        r(74569),
        r(21801),
        r(73796),
        r(60947),
        r(91597),
        r(35132),
        r(89623),
        r(84069),
        r(44567),
        r(98380),
        r(92896),
        r(22781),
        r(32422);
      const c = ['oid', 'global-id'],
        u = ['oid', 'global-id', 'guid'];
      function p({ displayField: e, editFieldsInfo: t, fields: r, objectIdField: o, title: a }, c) {
        if (!r) return null;
        const u = w({ editFieldsInfo: t, fields: r, objectIdField: o }, c);
        if (!u.length) return null;
        const p = (function (e) {
            const t = (0, i.O5)(e),
              { titleBase: r } = e;
            return t ? `${r}: {${t.trim()}}` : r;
          })({ titleBase: a, fields: r, displayField: e }),
          d = [new l.Z(), new s.Z()];
        return new n.Z({ title: p, content: d, fieldInfos: u });
      }
      const d = [
          /^fnode_$/i,
          /^tnode_$/i,
          /^lpoly_$/i,
          /^rpoly_$/i,
          /^poly_$/i,
          /^subclass$/i,
          /^subclass_$/i,
          /^rings_ok$/i,
          /^rings_nok$/i,
          /shape/i,
          /perimeter/i,
          /objectid/i,
          /_i$/i,
        ],
        f = (e, { editFieldsInfo: t, objectIdField: r, visibleFieldNames: n }) =>
          n
            ? n.has(e.name)
            : !(
                m(e.name, t) ||
                (r && e.name === r) ||
                c.indexOf(e.type) > -1 ||
                d.some((t) => t.test(e.name))
              );
      function b(e, t) {
        return 'oid' === e.type
          ? -1
          : 'oid' === t.type
          ? 1
          : y(e)
          ? -1
          : y(t)
          ? 1
          : (e.alias || e.name)
              .toLocaleLowerCase()
              .localeCompare((t.alias || t.name).toLocaleLowerCase());
      }
      function m(e, t) {
        if (!e || !t) return !1;
        const { creationDateField: r, creatorField: n, editDateField: i, editorField: s } = t;
        return (
          -1 !==
          [
            r && r.toLowerCase(),
            n && n.toLowerCase(),
            i && i.toLowerCase(),
            s && s.toLowerCase(),
          ].indexOf(e.toLowerCase())
        );
      }
      function h(e, t) {
        return e.editable && -1 === u.indexOf(e.type) && !m(e.name, t);
      }
      function w({ editFieldsInfo: e, fields: t, objectIdField: r }, n) {
        return (function (e, t) {
          const r = e;
          return (
            t && (e = e.filter((e) => -1 === t.indexOf(e.type))),
            e === r && (e = e.slice()),
            e.sort(b),
            e
          );
        })(t, (null == n ? void 0 : n.ignoreFieldTypes) || g).map(
          (t) =>
            new o.Z({
              fieldName: t.name,
              isEditable: h(t, e),
              label: t.alias,
              format: v(t),
              visible: f(t, {
                editFieldsInfo: e,
                objectIdField: r,
                visibleFieldNames: null == n ? void 0 : n.visibleFieldNames,
              }),
            }),
        );
      }
      function v(e) {
        switch (e.type) {
          case 'small-integer':
          case 'integer':
          case 'single':
            return new a.Z({ digitSeparator: !0, places: 0 });
          case 'double':
            return new a.Z({ digitSeparator: !0, places: 2 });
          case 'date':
            return new a.Z({ dateFormat: 'long-month-day-year' });
          default:
            return null;
        }
      }
      function y(e) {
        return (
          'name' === (e.name && e.name.toLowerCase()) ||
          'name' === (e.alias && e.alias.toLowerCase()) ||
          void 0
        );
      }
      const g = ['geometry', 'blob', 'raster', 'guid', 'xml'];
    },
  },
]);
