(self.webpackChunkRemoteClient = self.webpackChunkRemoteClient || []).push([
  [9506],
  {
    48687: (e, t, r) => {
      'use strict';
      r.d(t, { F: () => T, M: () => x });
      var i = r(29768),
        o = (r(74569), r(23761)),
        s = r(15324),
        n = r(60991),
        a = r(76506),
        l = r(22739),
        p = r(92143),
        u = r(20543),
        d = r(65514),
        y = r(34250),
        c = r(91306),
        h = r(17533),
        m = r(55823),
        b = r(92847),
        f = r(87258),
        g = r(21801),
        w = r(44567),
        v = r(22781),
        _ = r(74673);
      let C = 0;
      const S = p.L.getLogger('esri.layers.graphics.sources.MemorySource');
      let F = class extends l.L.LoadableMixin((0, u.a)(s.Z)) {
        constructor(e) {
          super(e), (this._idToClientGraphic = null), (this.type = 'memory');
        }
        load(e) {
          const t = (0, a.i)(e) ? e.signal : null;
          return this.addResolvingPromise(this._startWorker(t)), Promise.resolve(this);
        }
        destroy() {
          var e;
          null == (e = this._connection) || e.close(), (this._connection = null);
        }
        get workerGeometryType() {
          var e;
          const t = null == (e = this.layer) ? void 0 : e.geometryType;
          return t ? (this._geometryTypeRequiresClientGraphicMapping(t) ? 'polygon' : t) : null;
        }
        applyEdits(e) {
          return this.load().then(() => this._applyEdits(e));
        }
        openPorts() {
          return this.load().then(() => this._connection.openPorts());
        }
        async queryFeatures(e, t = {}) {
          await this.load(t);
          const r = await this._connection.invoke('queryFeatures', e ? e.toJSON() : null, t);
          (0, m.a)(e, this.layer.spatialReference, r);
          const i = f.default.fromJSON(r);
          if (!this._requiresClientGraphicMapping()) return i;
          const o = this.layer.objectIdField;
          for (const e of i.features) {
            const t = e.attributes[o],
              r = this._idToClientGraphic.get(t);
            r && (e.geometry = r.geometry);
          }
          return (i.geometryType = this.layer.geometryType), i;
        }
        async queryFeaturesJSON(e, t = {}) {
          if (this._requiresClientGraphicMapping())
            throw new n.Z(
              'query-features-json:unsupported',
              'Cannot query in JSON format for client only geometry types (mesh and extent)',
            );
          await this.load(t);
          const r = await this._connection.invoke('queryFeatures', e ? e.toJSON() : null, t);
          return (0, m.a)(e, this.layer.spatialReference, r), r;
        }
        queryFeatureCount(e, t = {}) {
          return this.load(t).then(() =>
            this._connection.invoke('queryFeatureCount', e ? e.toJSON() : null, t),
          );
        }
        queryObjectIds(e, t = {}) {
          return this.load(t).then(() =>
            this._connection.invoke('queryObjectIds', e ? e.toJSON() : null, t),
          );
        }
        queryExtent(e, t = {}) {
          return this.load(t)
            .then(() => this._connection.invoke('queryExtent', e ? e.toJSON() : null, t))
            .then((e) => ({ count: e.count, extent: g.Z.fromJSON(e.extent) }));
        }
        querySnapping(e, t = {}) {
          return this.load(t).then(() => this._connection.invoke('querySnapping', e, t));
        }
        async _applyEdits(e) {
          if (!this._connection)
            throw new n.Z('feature-layer-source:edit-failure', 'Memory source not loaded');
          const t = this.layer.objectIdField;
          let r = null;
          const i = [],
            o = [];
          await Promise.all([
            this._prepareClientMapping(e.addFeatures, null),
            this._prepareClientMapping(e.updateFeatures, null),
          ]);
          const s = (e) =>
            'objectId' in e && null != e.objectId
              ? e.objectId
              : 'attributes' in e && null != e.attributes[t]
              ? e.attributes[t]
              : null;
          if ((e.addFeatures && (r = this._prepareAddFeatures(e.addFeatures)), e.deleteFeatures))
            for (const t of e.deleteFeatures) {
              const e = s(t);
              null != e && i.push(e);
            }
          const a = e.updateFeatures && this._idToClientGraphic ? new Map() : null;
          if (e.updateFeatures)
            for (const t of e.updateFeatures)
              if ((o.push(this._serializeFeature(t)), a)) {
                const e = s(t);
                null != e && a.set(e, t);
              }
          (0, b.u)(r ? r.features : null, o, this.layer.spatialReference);
          const { fullExtent: l, featureEditResults: p } = await this._connection.invoke(
            'applyEdits',
            {
              adds: r ? r.features : [],
              updates: o,
              deletes: i,
            },
          );
          return (
            (this.fullExtent = l),
            r && r.finish(p.uidToObjectId),
            this._updateClientGraphicIds(a, p),
            this._createEditsResult(p)
          );
        }
        async _prepareClientMapping(e, t) {
          if ('mesh' !== this.layerOrSourceGeometryType || (0, a.b)(e)) return;
          const r = [];
          for (const { geometry: i } of e)
            !(0, a.i)(i) ||
              'mesh' !== i.type ||
              i.hasExtent ||
              i.loaded ||
              r.push(i.load({ signal: t }));
          r.length && (await Promise.all(r));
        }
        _updateClientGraphicIds(e, t) {
          if (this._idToClientGraphic) {
            if (e)
              for (const r of t.updateResults) {
                if (!r.success) continue;
                const t = e.get(r.objectId);
                null != t && this._addIdToClientGraphic(t);
              }
            for (const e of t.deleteResults)
              e.success && this._idToClientGraphic.delete(e.objectId);
          }
        }
        _createEditsResult(e) {
          return {
            addFeatureResults: e.addResults
              ? e.addResults.map(this._createFeatureEditResult, this)
              : [],
            updateFeatureResults: e.updateResults
              ? e.updateResults.map(this._createFeatureEditResult, this)
              : [],
            deleteFeatureResults: e.deleteResults
              ? e.deleteResults.map(this._createFeatureEditResult, this)
              : [],
            addAttachmentResults: [],
            updateAttachmentResults: [],
            deleteAttachmentResults: [],
          };
        }
        _createFeatureEditResult(e) {
          const t = !0 === e.success ? null : e.error || { code: void 0, description: void 0 };
          return {
            objectId: e.objectId,
            globalId: e.globalId,
            error: t
              ? new n.Z('feature-layer-source:edit-failure', t.description, { code: t.code })
              : null,
          };
        }
        _prepareAddFeatures(e) {
          const t = new Map(),
            r = new Array(e.length);
          let i = null;
          for (let o = 0; o < e.length; o++) {
            const s = e[o],
              n = this._serializeFeature(s);
            !i && (0, a.i)(s.geometry) && (i = s.geometry.type), (r[o] = n), t.set(`${n.uid}`, s);
          }
          const o = this;
          return {
            features: r,
            inferredGeometryType: i,
            finish(e) {
              const r = o.sourceJSON.objectIdField;
              for (const i in e) {
                const s = e[i],
                  n = t.get(i);
                n &&
                  (n.attributes || (n.attributes = {}),
                  -1 === s ? delete n.attributes[r] : (n.attributes[r] = s),
                  o._addIdToClientGraphic(n));
              }
            },
          };
        }
        _addIdToClientGraphic(e) {
          if (!this._idToClientGraphic) return;
          const t = this.sourceJSON.objectIdField,
            r = e.attributes && e.attributes[t];
          null != r && this._idToClientGraphic.set(r, e);
        }
        get layerOrSourceGeometryType() {
          var e, t, r;
          return null != (e = null == (t = this.layer) ? void 0 : t.geometryType)
            ? e
            : null == (r = this.sourceJSON)
            ? void 0
            : r.geometryType;
        }
        _requiresClientGraphicMapping() {
          return this._geometryTypeRequiresClientGraphicMapping(this.layerOrSourceGeometryType);
        }
        _geometryRequiresClientGraphicMapping(e) {
          return this._geometryTypeRequiresClientGraphicMapping(e.type);
        }
        _geometryTypeRequiresClientGraphicMapping(e) {
          return 'mesh' === e || 'multipatch' === e || 'extent' === e;
        }
        _serializeFeature(e) {
          const { attributes: t } = e,
            r = this._geometryForSerialization(e),
            i = (C++).toString();
          return r ? { uid: i, geometry: r.toJSON(), attributes: t } : { uid: i, attributes: t };
        }
        _geometryForSerialization(e) {
          const { geometry: t } = e;
          return (0, a.b)(t)
            ? null
            : this._geometryRequiresClientGraphicMapping(t)
            ? t.extent
              ? w.Z.fromExtent(t.extent)
              : null
            : t;
        }
        async _startWorker(e) {
          this._connection = await (0, d.bA)('MemorySourceWorker', {
            strategy: (0, a.h)('feature-layers-workers') ? 'dedicated' : 'local',
            signal: e,
          });
          const {
              fields: t,
              spatialReference: r,
              objectIdField: i,
              hasM: o,
              hasZ: s,
              timeInfo: n,
            } = this.layer,
            l = 'defaults' === this.layer.originOf('spatialReference');
          await this._prepareClientMapping(this.items, e);
          const p = this._prepareAddFeatures(this.items);
          this.on('before-changes', (e) => {
            S.error(
              'Source modifications will not propagate after layer has been loaded. Please use .applyEdits() instead',
            ),
              e.preventDefault();
          });
          const u = {
              features: p.features,
              fields: t && t.map((e) => e.toJSON()),
              geometryType: v.t.toJSON(this.workerGeometryType),
              hasM: 'mesh' !== this.layerOrSourceGeometryType && o,
              hasZ: 'mesh' === this.layerOrSourceGeometryType || s,
              objectIdField: i,
              spatialReference: l ? null : r && r.toJSON(),
              timeInfo: n ? n.toJSON() : null,
            },
            y = await this._connection.invoke('load', u, { signal: e });
          for (const e of y.warnings) S.warn(e.message, { layer: this.layer, warning: e });
          y.featureErrors.length &&
            S.warn(
              `Encountered ${y.featureErrors.length} validation errors while loading features`,
              y.featureErrors,
            );
          const c = y.layerDefinition;
          this._geometryTypeRequiresClientGraphicMapping(p.inferredGeometryType) &&
            (c.geometryType = v.t.toJSON(p.inferredGeometryType)),
            (this.sourceJSON = c),
            this._requiresClientGraphicMapping() && (this._idToClientGraphic = new Map()),
            p.finish(y.assignedObjectIds);
        }
      };
      var j;
      (0, i._)(
        [
          ((j = { Type: o.Z, ensureType: (0, c.e)(o.Z) }),
          (e, t) => {
            e[t] = j;
          }),
        ],
        F.prototype,
        'itemType',
        void 0,
      ),
        (0, i._)([(0, y.Cb)()], F.prototype, 'type', void 0),
        (0, i._)([(0, y.Cb)({ constructOnly: !0 })], F.prototype, 'layer', void 0),
        (0, i._)([(0, y.Cb)({ readOnly: !0 })], F.prototype, 'workerGeometryType', null),
        (0, i._)([(0, y.Cb)()], F.prototype, 'sourceJSON', void 0),
        (F = (0, i._)([(0, h.j)('esri.layers.graphics.sources.MemorySource')], F));
      var I,
        x = F;
      let T = (I = class extends _.a {
        constructor(e) {
          super(e);
        }
        clone() {
          const { name: e, fields: t, isAscending: r, isUnique: i, description: o } = this;
          return new I({ name: e, fields: t, isAscending: r, isUnique: i, description: o });
        }
      });
      (0, i._)([(0, y.Cb)({ constructOnly: !0 })], T.prototype, 'name', void 0),
        (0, i._)([(0, y.Cb)({ constructOnly: !0 })], T.prototype, 'fields', void 0),
        (0, i._)([(0, y.Cb)({ constructOnly: !0 })], T.prototype, 'isAscending', void 0),
        (0, i._)([(0, y.Cb)({ constructOnly: !0 })], T.prototype, 'isUnique', void 0),
        (0, i._)([(0, y.Cb)({ constructOnly: !0 })], T.prototype, 'description', void 0),
        (T = I = (0, i._)([(0, h.j)('esri.layers.support.FeatureIndex')], T));
    },
    68714: (e, t, r) => {
      'use strict';
      r.d(t, { l: () => n });
      var i = r(41864),
        o = r(50406),
        s = r(17533);
      async function n(e, t, r) {
        const n = e && e.getAtOrigin && e.getAtOrigin('renderer', t.origin);
        if (n && 'unique-value' === n.type && n.styleOrigin) {
          const a = await (0, i.r)(n.populateFromStyle());
          if (((0, o.k_)(r), !1 === a.ok)) {
            const r = a.error;
            t &&
              t.messages &&
              t.messages.push(
                new s.W(
                  'renderer:style-reference',
                  `Failed to create unique value renderer from style reference: ${r.message}`,
                  { error: r, context: t },
                ),
              ),
              e.clear('renderer', t.origin);
          }
        }
      }
    },
    38949: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => p });
      var i,
        o = r(29768),
        s = r(74673),
        n = r(34250),
        a = (r(76506), r(91306), r(92143), r(17533));
      r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(81172),
        r(71552),
        r(31450),
        r(40642),
        r(26341);
      let l = (i = class extends s.a {
        constructor(e) {
          super(e),
            (this.expression = null),
            (this.name = null),
            (this.returnType = 'boolean'),
            (this.title = null);
        }
        clone() {
          return new i({
            name: this.name,
            title: this.title,
            expression: this.expression,
            returnType: this.returnType,
          });
        }
      });
      (0, o._)(
        [(0, n.Cb)({ type: String, json: { write: !0 } })],
        l.prototype,
        'expression',
        void 0,
      ),
        (0, o._)([(0, n.Cb)({ type: String, json: { write: !0 } })], l.prototype, 'name', void 0),
        (0, o._)(
          [(0, n.Cb)({ type: ['boolean'], json: { write: !0 } })],
          l.prototype,
          'returnType',
          void 0,
        ),
        (0, o._)([(0, n.Cb)({ type: String, json: { write: !0 } })], l.prototype, 'title', void 0),
        (l = i = (0, o._)([(0, a.j)('esri.form.ExpressionInfo')], l));
      const p = l;
    },
    10691: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => f });
      var i,
        o = r(29768),
        s = r(74673),
        n = r(76506),
        a = r(34250),
        l = r(86787),
        p = (r(92143), r(97714)),
        u = r(17533),
        d = r(2906),
        y = r(38949),
        c = r(71777),
        h = r(62554);
      r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(81172),
        r(71552),
        r(31450),
        r(40642),
        r(91306),
        r(26341),
        r(27371),
        r(78648),
        r(87558),
        r(13063),
        r(17153),
        r(35962),
        r(9252),
        r(67350),
        r(11471),
        r(83748),
        r(28376),
        r(9801),
        r(53523),
        r(59465),
        r(57251),
        r(42911),
        r(46826),
        r(45433),
        r(30493);
      const m = (0, h.gr)(c.Z);
      let b = (i = class extends s.a {
        constructor(e) {
          super(e),
            (this.description = null),
            (this.elements = null),
            (this.expressionInfos = null),
            (this.title = null);
        }
        castElements(e) {
          return (0, h.se)(e, m);
        }
        readElements(e, t) {
          return (0, h.im)(t.formElements, m);
        }
        writeElements(e, t) {
          t.formElements = (0, h.au)(e, m);
        }
        clone() {
          return new i({
            description: this.description,
            expressionInfos: (0, n.d9)(this.expressionInfos),
            elements: (0, n.d9)(this.elements),
            title: this.title,
          });
        }
      });
      (0, o._)(
        [(0, a.Cb)({ type: String, json: { write: !0 } })],
        b.prototype,
        'description',
        void 0,
      ),
        (0, o._)([(0, a.Cb)({ json: { write: !0 } })], b.prototype, 'elements', void 0),
        (0, o._)([(0, l.p)('elements')], b.prototype, 'castElements', null),
        (0, o._)([(0, p.r)('elements', ['formElements'])], b.prototype, 'readElements', null),
        (0, o._)([(0, d.w)('elements')], b.prototype, 'writeElements', null),
        (0, o._)(
          [(0, a.Cb)({ type: [y.Z], json: { write: !0 } })],
          b.prototype,
          'expressionInfos',
          void 0,
        ),
        (0, o._)([(0, a.Cb)({ type: String, json: { write: !0 } })], b.prototype, 'title', void 0),
        (b = i = (0, o._)([(0, u.j)('esri.form.FormTemplate')], b));
      const f = b;
    },
    27371: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => c, E: () => d });
      var i = r(29768),
        o = r(34250),
        s = (r(76506), r(91306), r(92143), r(17533)),
        n = r(74673),
        a = r(78648),
        l = r(9801);
      r(86656),
        r(22723),
        r(31450),
        r(71552),
        r(40642),
        r(81172),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341),
        r(87558),
        r(13063),
        r(17153),
        r(35962),
        r(9252),
        r(97714),
        r(2906),
        r(67350),
        r(11471),
        r(83748),
        r(28376),
        r(53523),
        r(59465),
        r(57251),
        r(42911),
        r(46826),
        r(45433);
      let p = class extends n.a {
        constructor(e) {
          super(e),
            (this.description = null),
            (this.label = null),
            (this.type = null),
            (this.visibilityExpression = null);
        }
      };
      (0, i._)(
        [(0, o.Cb)({ type: String, json: { write: !0 } })],
        p.prototype,
        'description',
        void 0,
      ),
        (0, i._)([(0, o.Cb)({ type: String, json: { write: !0 } })], p.prototype, 'label', void 0),
        (0, i._)([(0, o.Cb)()], p.prototype, 'type', void 0),
        (0, i._)(
          [(0, o.Cb)({ type: String, json: { write: !0 } })],
          p.prototype,
          'visibilityExpression',
          void 0,
        ),
        (p = (0, i._)([(0, s.j)('esri.form.elements.Element')], p));
      var u,
        d = p;
      let y = (u = class extends d {
        constructor(e) {
          super(e),
            (this.domain = null),
            (this.editable = !0),
            (this.fieldName = null),
            (this.hint = null),
            (this.input = null),
            (this.requiredExpression = null),
            (this.type = 'field');
        }
        clone() {
          return new u({
            description: this.description,
            domain: this.domain,
            editable: this.editable,
            fieldName: this.fieldName,
            hint: this.hint,
            input: this.input,
            label: this.label,
            requiredExpression: this.requiredExpression,
            visibilityExpression: this.visibilityExpression,
          });
        }
      });
      (0, i._)(
        [(0, o.Cb)({ types: l.t, json: { read: { reader: l.f }, write: !0 } })],
        y.prototype,
        'domain',
        void 0,
      ),
        (0, i._)(
          [(0, o.Cb)({ type: Boolean, json: { write: !0 } })],
          y.prototype,
          'editable',
          void 0,
        ),
        (0, i._)(
          [(0, o.Cb)({ type: String, json: { write: !0 } })],
          y.prototype,
          'fieldName',
          void 0,
        ),
        (0, i._)([(0, o.Cb)({ type: String, json: { write: !0 } })], y.prototype, 'hint', void 0),
        (0, i._)(
          [
            (0, o.Cb)({
              types: a.V,
              json: { read: { source: 'inputType' }, write: { target: 'inputType' } },
            }),
          ],
          y.prototype,
          'input',
          void 0,
        ),
        (0, i._)(
          [(0, o.Cb)({ type: String, json: { write: !0 } })],
          y.prototype,
          'requiredExpression',
          void 0,
        ),
        (0, i._)(
          [(0, o.Cb)({ type: String, json: { read: !1, write: !0 } })],
          y.prototype,
          'type',
          void 0,
        ),
        (y = u = (0, i._)([(0, s.j)('esri.form.elements.FieldElement')], y));
      const c = y;
    },
    71777: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => m });
      var i,
        o = r(29768),
        s = r(76506),
        n = r(34250),
        a = r(86787),
        l = (r(92143), r(97714)),
        p = r(17533),
        u = r(2906),
        d = r(27371),
        y = r(62554);
      r(91306),
        r(86656),
        r(22723),
        r(31450),
        r(71552),
        r(40642),
        r(81172),
        r(74673),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341),
        r(78648),
        r(87558),
        r(13063),
        r(17153),
        r(35962),
        r(9252),
        r(67350),
        r(11471),
        r(83748),
        r(28376),
        r(9801),
        r(53523),
        r(59465),
        r(57251),
        r(42911),
        r(46826),
        r(45433),
        r(30493);
      let c = (i = class extends d.E {
        constructor(e) {
          super(e), (this.elements = null), (this.initialState = 'expanded'), (this.type = 'group');
        }
        castElements(e) {
          return (0, y.se)(e, h, !1);
        }
        readElements(e, t) {
          return (0, y.im)(t.formElements, h, !1);
        }
        writeElements(e, t) {
          t.formElements = (0, y.au)(e, h, !1);
        }
        clone() {
          return new i({
            description: this.description,
            elements: (0, s.d9)(this.elements),
            initialState: this.initialState,
            label: this.label,
            visibilityExpression: this.visibilityExpression,
          });
        }
      });
      (0, o._)([(0, n.Cb)({ json: { write: !0 } })], c.prototype, 'elements', void 0),
        (0, o._)([(0, a.p)('elements')], c.prototype, 'castElements', null),
        (0, o._)([(0, l.r)('elements', ['formElements'])], c.prototype, 'readElements', null),
        (0, o._)([(0, u.w)('elements')], c.prototype, 'writeElements', null),
        (0, o._)(
          [(0, n.Cb)({ type: ['collapsed', 'expanded'], json: { write: !0 } })],
          c.prototype,
          'initialState',
          void 0,
        ),
        (0, o._)(
          [(0, n.Cb)({ type: String, json: { read: !1, write: !0 } })],
          c.prototype,
          'type',
          void 0,
        ),
        (c = i = (0, o._)([(0, p.j)('esri.form.elements.GroupElement')], c));
      const h = (0, y.gr)(c),
        m = c;
    },
    87558: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => p });
      var i,
        o = r(29768),
        s = r(34250),
        n = (r(76506), r(91306), r(92143), r(17533)),
        a = r(13063);
      r(86656),
        r(22723),
        r(31450),
        r(71552),
        r(40642),
        r(81172),
        r(17153),
        r(74673),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341);
      let l = (i = class extends a.Z {
        constructor(e) {
          super(e), (this.type = 'barcode-scanner');
        }
        clone() {
          return new i({ maxLength: this.maxLength, minLength: this.minLength });
        }
      });
      (0, o._)(
        [(0, s.Cb)({ type: ['barcode-scanner'], json: { read: !1, write: !0 } })],
        l.prototype,
        'type',
        void 0,
      ),
        (l = i = (0, o._)([(0, n.j)('esri.form.elements.inputs.BarcodeScannerInput')], l));
      const p = l;
    },
    35962: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => p });
      var i,
        o = r(29768),
        s = r(34250),
        n = (r(76506), r(91306), r(92143), r(17533)),
        a = r(17153);
      r(86656),
        r(22723),
        r(31450),
        r(71552),
        r(40642),
        r(81172),
        r(74673),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341);
      let l = (i = class extends a.Z {
        constructor(e) {
          super(e),
            (this.noValueOptionLabel = null),
            (this.showNoValueOption = !1),
            (this.type = 'combo-box');
        }
        clone() {
          return new i({
            showNoValueOption: this.showNoValueOption,
            noValueOptionLabel: this.noValueOptionLabel,
          });
        }
      });
      (0, o._)(
        [(0, s.Cb)({ type: String, json: { write: !0 } })],
        l.prototype,
        'noValueOptionLabel',
        void 0,
      ),
        (0, o._)(
          [(0, s.Cb)({ type: Boolean, json: { write: !0 } })],
          l.prototype,
          'showNoValueOption',
          void 0,
        ),
        (0, o._)(
          [(0, s.Cb)({ type: ['combo-box'], json: { read: !1, write: !0 } })],
          l.prototype,
          'type',
          void 0,
        ),
        (l = i = (0, o._)([(0, n.j)('esri.form.elements.inputs.ComboBoxInput')], l));
      const p = l;
    },
    9252: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => c });
      var i,
        o = r(29768),
        s = r(34250),
        n = (r(76506), r(91306), r(92143), r(97714)),
        a = r(17533),
        l = r(2906),
        p = r(17153);
      function u(e) {
        return null != e ? new Date(e) : null;
      }
      function d(e) {
        return e ? e.getTime() : null;
      }
      r(86656),
        r(22723),
        r(31450),
        r(71552),
        r(40642),
        r(81172),
        r(74673),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341);
      let y = (i = class extends p.Z {
        constructor(e) {
          super(e),
            (this.includeTime = !1),
            (this.max = null),
            (this.min = null),
            (this.type = 'datetime-picker');
        }
        readMax(e, t) {
          return u(t.max);
        }
        writeMax(e, t) {
          t.max = d(e);
        }
        readMin(e, t) {
          return u(t.min);
        }
        writeMin(e, t) {
          t.min = d(e);
        }
        clone() {
          return new i({
            includeTime: this.includeTime,
            max: this.max,
            min: this.min,
            type: this.type,
          });
        }
      });
      (0, o._)(
        [(0, s.Cb)({ type: Boolean, json: { write: !0 } })],
        y.prototype,
        'includeTime',
        void 0,
      ),
        (0, o._)(
          [(0, s.Cb)({ type: Date, json: { type: Number, write: !0 } })],
          y.prototype,
          'max',
          void 0,
        ),
        (0, o._)([(0, n.r)('max')], y.prototype, 'readMax', null),
        (0, o._)([(0, l.w)('max')], y.prototype, 'writeMax', null),
        (0, o._)(
          [(0, s.Cb)({ type: Date, json: { type: Number, write: !0 } })],
          y.prototype,
          'min',
          void 0,
        ),
        (0, o._)([(0, n.r)('min')], y.prototype, 'readMin', null),
        (0, o._)([(0, l.w)('min')], y.prototype, 'writeMin', null),
        (0, o._)(
          [(0, s.Cb)({ type: ['datetime-picker'], json: { read: !1, write: !0 } })],
          y.prototype,
          'type',
          void 0,
        ),
        (y = i = (0, o._)([(0, a.j)('esri.form.elements.inputs.DateTimePickerInput')], y));
      const c = y;
    },
    17153: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => l });
      var i = r(29768),
        o = r(74673),
        s = r(34250),
        n = (r(76506), r(91306), r(92143), r(17533));
      r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(81172),
        r(71552),
        r(31450),
        r(40642),
        r(26341);
      let a = class extends o.a {
        constructor(e) {
          super(e), (this.type = null);
        }
      };
      (0, i._)([(0, s.Cb)()], a.prototype, 'type', void 0),
        (a = (0, i._)([(0, n.j)('esri.form.elements.inputs.Input')], a));
      const l = a;
    },
    67350: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => p });
      var i,
        o = r(29768),
        s = r(34250),
        n = (r(76506), r(91306), r(92143), r(17533)),
        a = r(17153);
      r(86656),
        r(22723),
        r(31450),
        r(71552),
        r(40642),
        r(81172),
        r(74673),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341);
      let l = (i = class extends a.Z {
        constructor(e) {
          super(e),
            (this.noValueOptionLabel = null),
            (this.showNoValueOption = !1),
            (this.type = 'radio-buttons');
        }
        clone() {
          return new i({
            noValueOptionLabel: this.noValueOptionLabel,
            showNoValueOption: this.showNoValueOption,
          });
        }
      });
      (0, o._)(
        [(0, s.Cb)({ type: String, json: { write: !0 } })],
        l.prototype,
        'noValueOptionLabel',
        void 0,
      ),
        (0, o._)(
          [(0, s.Cb)({ type: Boolean, json: { write: !0 } })],
          l.prototype,
          'showNoValueOption',
          void 0,
        ),
        (0, o._)(
          [(0, s.Cb)({ type: ['radio-buttons'], json: { read: !1, write: !0 } })],
          l.prototype,
          'type',
          void 0,
        ),
        (l = i = (0, o._)([(0, n.j)('esri.form.elements.inputs.RadioButtonsInput')], l));
      const p = l;
    },
    11471: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => p });
      var i,
        o = r(29768),
        s = r(34250),
        n = (r(76506), r(91306), r(92143), r(17533)),
        a = r(17153);
      r(86656),
        r(22723),
        r(31450),
        r(71552),
        r(40642),
        r(81172),
        r(74673),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341);
      let l = (i = class extends a.Z {
        constructor(e) {
          super(e), (this.offValue = null), (this.onValue = null), (this.type = 'switch');
        }
        clone() {
          return new i({ offValue: this.offValue, onValue: this.onValue });
        }
      });
      (0, o._)(
        [(0, s.Cb)({ type: [String, Number], json: { write: !0 } })],
        l.prototype,
        'offValue',
        void 0,
      ),
        (0, o._)(
          [(0, s.Cb)({ type: [String, Number], json: { write: !0 } })],
          l.prototype,
          'onValue',
          void 0,
        ),
        (0, o._)(
          [(0, s.Cb)({ type: ['switch'], json: { read: !1, write: !0 } })],
          l.prototype,
          'type',
          void 0,
        ),
        (l = i = (0, o._)([(0, n.j)('esri.form.elements.inputs.SwitchInput')], l));
      const p = l;
    },
    83748: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => p });
      var i,
        o = r(29768),
        s = r(34250),
        n = (r(76506), r(91306), r(92143), r(17533)),
        a = r(13063);
      r(86656),
        r(22723),
        r(31450),
        r(71552),
        r(40642),
        r(81172),
        r(17153),
        r(74673),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341);
      let l = (i = class extends a.Z {
        constructor(e) {
          super(e), (this.type = 'text-area');
        }
        clone() {
          return new i({ maxLength: this.maxLength, minLength: this.minLength });
        }
      });
      (0, o._)(
        [(0, s.Cb)({ type: ['text-area'], json: { read: !1, write: !0 } })],
        l.prototype,
        'type',
        void 0,
      ),
        (l = i = (0, o._)([(0, n.j)('esri.form.elements.inputs.TextAreaInput')], l));
      const p = l;
    },
    28376: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => p });
      var i,
        o = r(29768),
        s = r(34250),
        n = (r(76506), r(91306), r(92143), r(17533)),
        a = r(13063);
      r(86656),
        r(22723),
        r(31450),
        r(71552),
        r(40642),
        r(81172),
        r(17153),
        r(74673),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341);
      let l = (i = class extends a.Z {
        constructor(e) {
          super(e), (this.type = 'text-box');
        }
        clone() {
          return new i({ maxLength: this.maxLength, minLength: this.minLength });
        }
      });
      (0, o._)(
        [(0, s.Cb)({ type: ['text-box'], json: { read: !1, write: !0 } })],
        l.prototype,
        'type',
        void 0,
      ),
        (l = i = (0, o._)([(0, n.j)('esri.form.elements.inputs.TextBoxInput')], l));
      const p = l;
    },
    13063: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => l });
      var i = r(29768),
        o = r(34250),
        s = (r(76506), r(91306), r(92143), r(17533)),
        n = r(17153);
      r(86656),
        r(22723),
        r(31450),
        r(71552),
        r(40642),
        r(81172),
        r(74673),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341);
      let a = class extends n.Z {
        constructor(e) {
          super(e), (this.maxLength = null), (this.minLength = 0);
        }
      };
      (0, i._)(
        [(0, o.Cb)({ type: Number, json: { write: !0 } })],
        a.prototype,
        'maxLength',
        void 0,
      ),
        (0, i._)(
          [(0, o.Cb)({ type: Number, json: { write: !0 } })],
          a.prototype,
          'minLength',
          void 0,
        ),
        (a = (0, i._)([(0, s.j)('esri.form.elements.inputs.TextInput')], a));
      const l = a;
    },
    78648: (e, t, r) => {
      'use strict';
      r.d(t, { V: () => d });
      var i = r(87558),
        o = r(35962),
        s = r(9252),
        n = r(17153),
        a = r(67350),
        l = r(11471),
        p = r(83748),
        u = r(28376);
      r(34250),
        r(92143),
        r(31450),
        r(76506),
        r(71552),
        r(40642),
        r(91306),
        r(86656),
        r(22723),
        r(17533),
        r(81172),
        r(13063),
        r(97714),
        r(2906),
        r(74673),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341);
      const d = {
        base: n.Z,
        key: 'type',
        typeMap: {
          'barcode-scanner': i.Z,
          'combo-box': o.Z,
          'datetime-picker': s.Z,
          'radio-buttons': a.Z,
          switch: l.Z,
          'text-area': p.Z,
          'text-box': u.Z,
        },
      };
    },
    62554: (e, t, r) => {
      'use strict';
      r.d(t, { gr: () => v, se: () => S, im: () => _, au: () => C });
      var i,
        o = r(91306),
        s = r(29768),
        n = r(34250),
        a = r(76506),
        l = (r(92143), r(17533)),
        p = r(27371),
        u = r(74673),
        d = r(30493);
      r(86656),
        r(22723),
        r(31450),
        r(71552),
        r(40642),
        r(81172),
        r(78648),
        r(87558),
        r(13063),
        r(17153),
        r(35962),
        r(9252),
        r(97714),
        r(2906),
        r(67350),
        r(11471),
        r(83748),
        r(28376),
        r(9801),
        r(53523),
        r(59465),
        r(57251),
        r(42911),
        r(21972),
        r(23639),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(26341),
        r(46826),
        r(45433);
      let y = (i = class extends u.a {
        constructor(e) {
          super(e), (this.type = null);
        }
        clone() {
          return new i({ type: this.type });
        }
      });
      (0, s._)(
        [
          (0, n.Cb)({
            type: ['attachment', 'audio', 'document', 'image', 'signature', 'video'],
            json: { write: !0 },
          }),
        ],
        y.prototype,
        'type',
        void 0,
      ),
        (y = i = (0, s._)([(0, l.j)('esri.form.elements.inputs.AttachmentInput')], y));
      var c,
        h = y;
      let m = (c = class extends p.E {
        constructor(e) {
          super(e),
            (this.attachmentKeyword = null),
            (this.editable = !0),
            (this.input = null),
            (this.type = 'attachment');
        }
        clone() {
          return new c({
            attachmentKeyword: this.attachmentKeyword,
            description: this.description,
            editable: this.editable,
            input: this.input,
            label: this.label,
            visibilityExpression: this.visibilityExpression,
          });
        }
      });
      (0, s._)(
        [(0, n.Cb)({ type: String, json: { write: !0 } })],
        m.prototype,
        'attachmentKeyword',
        void 0,
      ),
        (0, s._)(
          [(0, n.Cb)({ type: Boolean, json: { write: !0 } })],
          m.prototype,
          'editable',
          void 0,
        ),
        (0, s._)(
          [
            (0, n.Cb)({
              type: h,
              json: { read: { source: 'inputType' }, write: { target: 'inputType' } },
            }),
          ],
          m.prototype,
          'input',
          void 0,
        ),
        (0, s._)(
          [(0, n.Cb)({ type: ['attachment'], json: { read: !1, write: !0 } })],
          m.prototype,
          'type',
          void 0,
        ),
        (m = c = (0, s._)([(0, l.j)('esri.form.elements.AttachmentElement')], m));
      var b,
        f = m;
      let g = (b = class extends p.E {
        constructor(e) {
          super(e),
            (this.displayCount = null),
            (this.displayType = 'list'),
            (this.editable = !0),
            (this.orderByFields = null),
            (this.relationshipId = null),
            (this.type = 'relationship');
        }
        clone() {
          return new b({
            description: this.description,
            displayCount: this.displayCount,
            displayType: this.displayType,
            editable: this.editable,
            label: this.label,
            orderByFields: (0, a.d9)(this.orderByFields),
            relationshipId: this.relationshipId,
            visibilityExpression: this.visibilityExpression,
          });
        }
      });
      (0, s._)(
        [(0, n.Cb)({ type: Number, json: { write: !0 } })],
        g.prototype,
        'displayCount',
        void 0,
      ),
        (0, s._)(
          [(0, n.Cb)({ type: ['list'], json: { write: !0 } })],
          g.prototype,
          'displayType',
          void 0,
        ),
        (0, s._)(
          [(0, n.Cb)({ type: Boolean, json: { write: !0 } })],
          g.prototype,
          'editable',
          void 0,
        ),
        (0, s._)(
          [(0, n.Cb)({ type: [d.Z], json: { write: !0 } })],
          g.prototype,
          'orderByFields',
          void 0,
        ),
        (0, s._)(
          [(0, n.Cb)({ type: Number, json: { write: !0 } })],
          g.prototype,
          'relationshipId',
          void 0,
        ),
        (0, s._)(
          [(0, n.Cb)({ type: ['relationship'], json: { read: !1, write: !0 } })],
          g.prototype,
          'type',
          void 0,
        ),
        (g = b = (0, s._)([(0, l.j)('esri.form.elements.RelationshipElement')], g));
      var w = g;
      function v(e) {
        return {
          typesWithGroup: {
            base: p.E,
            key: 'type',
            typeMap: { attachment: f, field: p.Z, group: e, relationship: w },
          },
          typesWithoutGroup: {
            base: p.E,
            key: 'type',
            typeMap: { attachment: f, field: p.Z, relationship: w },
          },
        };
      }
      function _(e, t, r = !0) {
        if (!e) return null;
        const i = r ? t.typesWithGroup.typeMap : t.typesWithoutGroup.typeMap;
        return e.filter((e) => i[e.type]).map((e) => i[e.type].fromJSON(e));
      }
      function C(e, t, r = !0) {
        if (!e) return null;
        const i = r ? t.typesWithGroup.typeMap : t.typesWithoutGroup.typeMap;
        return e.filter((e) => i[e.type]).map((e) => e.toJSON());
      }
      function S(e, t, r = !0) {
        return e ? e.map((e) => (0, o.a)(r ? t.typesWithGroup : t.typesWithoutGroup, e)) : null;
      }
    },
    29027: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => g });
      var i,
        o = r(29768),
        s = r(27794),
        n = r(57251),
        a = r(74673),
        l = r(53785),
        p = r(17533),
        u = r(34250),
        d = (r(76506), r(91306), r(92143), r(97714)),
        y = r(2906);
      r(71552),
        r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(6906),
        r(50406),
        r(60991),
        r(81172),
        r(31450),
        r(40642),
        r(26341),
        r(95587),
        r(60947),
        r(89623);
      const c = (0, n.s)()({
          orthometric: 'gravity-related-height',
          gravity_related_height: 'gravity-related-height',
          ellipsoidal: 'ellipsoidal',
        }),
        h = c.jsonValues.slice();
      (0, s.r)(h, 'orthometric');
      const m = (0, n.s)()({
        meter: 'meters',
        foot: 'feet',
        'us-foot': 'us-feet',
        'clarke-foot': 'clarke-feet',
        'clarke-yard': 'clarke-yards',
        'clarke-link': 'clarke-links',
        'sears-yard': 'sears-yards',
        'sears-foot': 'sears-feet',
        'sears-chain': 'sears-chains',
        'benoit-1895-b-chain': 'benoit-1895-b-chains',
        'indian-yard': 'indian-yards',
        'indian-1937-yard': 'indian-1937-yards',
        'gold-coast-foot': 'gold-coast-feet',
        'sears-1922-truncated-chain': 'sears-1922-truncated-chains',
        '50-kilometers': '50-kilometers',
        '150-kilometers': '150-kilometers',
      });
      let b = (i = class extends a.a {
        constructor(e) {
          super(e),
            (this.heightModel = 'gravity-related-height'),
            (this.heightUnit = 'meters'),
            (this.vertCRS = null);
        }
        writeHeightModel(e, t, r) {
          return c.write(e, t, r);
        }
        readHeightModel(e, t, r) {
          return (
            c.read(e) ||
            (r &&
              r.messages &&
              r.messages.push(
                (function (e, t) {
                  return new p.W(
                    'height-model:unsupported',
                    `Height model of value '${e}' is not supported`,
                    t,
                  );
                })(e, { context: r }),
              ),
            null)
          );
        }
        readHeightUnit(e, t, r) {
          return m.read(e) || (r && r.messages && r.messages.push(f(e, { context: r })), null);
        }
        readHeightUnitService(e, t, r) {
          return (
            (0, l.u)(e) ||
            m.read(e) ||
            (r && r.messages && r.messages.push(f(e, { context: r })), null)
          );
        }
        readVertCRS(e, t) {
          return t.vertCRS || t.ellipsoid || t.geoid;
        }
        clone() {
          return new i({
            heightModel: this.heightModel,
            heightUnit: this.heightUnit,
            vertCRS: this.vertCRS,
          });
        }
        equals(e) {
          return (
            !!e &&
            (this === e ||
              (this.heightModel === e.heightModel &&
                this.heightUnit === e.heightUnit &&
                this.vertCRS === e.vertCRS))
          );
        }
        static deriveUnitFromSR(e, t) {
          const r = (0, l.g)(t);
          return new i({ heightModel: e.heightModel, heightUnit: r, vertCRS: e.vertCRS });
        }
        write(e, t) {
          return (t = { origin: 'web-scene', ...t }), super.write(e, t);
        }
        static fromJSON(e) {
          if (!e) return null;
          const t = new i();
          return t.read(e, { origin: 'web-scene' }), t;
        }
      });
      function f(e, t) {
        return new p.W(
          'height-unit:unsupported',
          `Height unit of value '${e}' is not supported`,
          t,
        );
      }
      (0, o._)(
        [
          (0, u.Cb)({
            type: c.apiValues,
            constructOnly: !0,
            json: { origins: { 'web-scene': { type: h, default: 'ellipsoidal' } } },
          }),
        ],
        b.prototype,
        'heightModel',
        void 0,
      ),
        (0, o._)([(0, y.w)('web-scene', 'heightModel')], b.prototype, 'writeHeightModel', null),
        (0, o._)(
          [(0, d.r)(['web-scene', 'service'], 'heightModel')],
          b.prototype,
          'readHeightModel',
          null,
        ),
        (0, o._)(
          [
            (0, u.Cb)({
              type: m.apiValues,
              constructOnly: !0,
              json: { origins: { 'web-scene': { type: m.jsonValues, write: m.write } } },
            }),
          ],
          b.prototype,
          'heightUnit',
          void 0,
        ),
        (0, o._)([(0, d.r)('web-scene', 'heightUnit')], b.prototype, 'readHeightUnit', null),
        (0, o._)([(0, d.r)('service', 'heightUnit')], b.prototype, 'readHeightUnitService', null),
        (0, o._)(
          [
            (0, u.Cb)({
              type: String,
              constructOnly: !0,
              json: { origins: { 'web-scene': { write: !0 } } },
            }),
          ],
          b.prototype,
          'vertCRS',
          void 0,
        ),
        (0, o._)(
          [(0, d.r)('service', 'vertCRS', ['vertCRS', 'ellipsoid', 'geoid'])],
          b.prototype,
          'readVertCRS',
          null,
        ),
        (b = i = (0, o._)([(0, p.j)('esri.geometry.HeightModelInfo')], b));
      const g = b;
    },
    9506: (e, t, r) => {
      'use strict';
      r.r(t), r.d(t, { default: () => ve });
      var i = r(29768),
        o = r(86748),
        s = (r(55306), r(71206), r(51979), r(60698), r(65684), r(86758)),
        n = r(95310),
        a = r(20208),
        l = r(82058),
        p = r(96467),
        u = r(15324),
        d = r(60991),
        y = r(82933),
        c = r(76506),
        h = r(57251),
        m = r(92143),
        b = r(54179),
        f = r(71552),
        g = r(50406),
        w = r(32101),
        v = r(34250),
        _ = r(86787),
        C = r(97714),
        S = r(17533),
        F = r(2906),
        j = r(10691),
        I = r(21801),
        x = r(29027),
        T = r(60947),
        E = r(41617),
        R = r(48687),
        M = r(21781),
        O = r(75025),
        Z = r(11118),
        D = r(8547),
        A = r(89440),
        q = r(62162),
        L = r(16647),
        P = r(58912),
        N = r(19902),
        G = r(21132),
        V = r(43022),
        k = r(13322),
        Q = r(14460),
        B = r(83290),
        U = r(46495),
        W = r(78303),
        J = r(47346),
        z = r(14249),
        H = r(17055),
        $ = r(77807),
        K = r(68653),
        Y = r(2180),
        X = r(14327),
        ee = r(77361),
        te = r(69218),
        re = r(68714),
        ie = r(34446),
        oe = r(87258),
        se = r(31292),
        ne = r(46646),
        ae = r(39210),
        le = r(78893);
      r(74673),
        r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(27794),
        r(6906),
        r(31450),
        r(40642),
        r(81172),
        r(91306),
        r(26341),
        r(29107),
        r(30574),
        r(2157),
        r(25977),
        r(7471),
        r(54414),
        r(59465),
        r(1648),
        r(8925),
        r(33921),
        r(3482),
        r(45154),
        r(16769),
        r(55531),
        r(30582),
        r(593),
        r(85699),
        r(63136),
        r(96055),
        r(47776),
        r(18033),
        r(6331),
        r(62048),
        r(4292),
        r(75626),
        r(72652),
        r(29641),
        r(30493),
        r(70821),
        r(82673),
        r(34229),
        r(37029),
        r(76996),
        r(9801),
        r(53523),
        r(42911),
        r(46826),
        r(45433),
        r(60217),
        r(74569),
        r(73796),
        r(84069),
        r(91597),
        r(35132),
        r(89623),
        r(44567),
        r(98380),
        r(92896),
        r(22781),
        r(32422),
        r(74071),
        r(51723),
        r(23243),
        r(51669),
        r(6090),
        r(48027),
        r(54174),
        r(82426),
        r(3977),
        r(36741),
        r(34394),
        r(11253),
        r(90319),
        r(38822),
        r(74057),
        r(23761),
        r(63571),
        r(30776),
        r(63130),
        r(25696),
        r(66396),
        r(42775),
        r(95834),
        r(57150),
        r(76726),
        r(20444),
        r(76393),
        r(78548),
        r(2497),
        r(49906),
        r(46527),
        r(48649),
        r(9960),
        r(3101),
        r(5853),
        r(39141),
        r(38742),
        r(48243),
        r(34635),
        r(10401),
        r(49900),
        r(66284),
        r(73173),
        r(88762),
        r(22739),
        r(20543),
        r(67477),
        r(78533),
        r(74653),
        r(91091),
        r(58943),
        r(70737),
        r(8487),
        r(17817),
        r(90814),
        r(15459),
        r(61847),
        r(16796),
        r(16955),
        r(22401),
        r(77894),
        r(55187),
        r(8586),
        r(44509),
        r(69814),
        r(11305),
        r(62259),
        r(44790),
        r(5909),
        r(60669),
        r(48208),
        r(51589),
        r(48190),
        r(85557),
        r(53785),
        r(95587),
        r(94070),
        r(16218),
        r(9075),
        r(67541),
        r(12158),
        r(74864),
        r(63683),
        r(94479),
        r(45702),
        r(51127),
        r(89241),
        r(91700),
        r(32037),
        r(90811),
        r(93939),
        r(238),
        r(71831),
        r(49500),
        r(50161),
        r(38949),
        r(71777),
        r(27371),
        r(78648),
        r(87558),
        r(13063),
        r(17153),
        r(35962),
        r(9252),
        r(67350),
        r(11471),
        r(83748),
        r(28376),
        r(62554),
        r(65514),
        r(46987),
        r(37453),
        r(55823),
        r(92847),
        r(41864),
        r(56420),
        r(74742),
        r(28239),
        r(93314),
        r(35197),
        r(59765),
        r(47842),
        r(17298),
        r(97546),
        r(54732),
        r(50203),
        r(30439),
        r(6941),
        r(27207),
        r(90549);
      const pe = new h.J({
          esriGeometryPoint: 'point',
          esriGeometryMultipoint: 'multipoint',
          esriGeometryPolyline: 'polyline',
          esriGeometryPolygon: 'polygon',
          esriGeometryMultiPatch: 'multipatch',
        }),
        ue = {
          name: 'supportsName',
          size: 'supportsSize',
          contentType: 'supportsContentType',
          keywords: 'supportsKeywords',
          exifInfo: 'supportsExifInfo',
        },
        de = 'FeatureLayer',
        ye = m.L.getLogger('esri.layers.FeatureLayer');
      function ce(e) {
        return e && e instanceof u.Z;
      }
      function he(e, t, r) {
        return !!(e && e.hasOwnProperty(t) ? e[t] : r);
      }
      function me(e, t, r) {
        return e && e.hasOwnProperty(t) ? e[t] : r;
      }
      const be = (0, J.d)();
      function fe(e, t, r) {
        const i = !(null == r || !r.writeLayerSchema);
        return { enabled: i, ignoreOrigin: i };
      }
      let ge = class extends (0, Z.B)(
        (0, N.T)(
          (0, P.S)((0, L.R)((0, O.A)((0, A.O)((0, q.P)((0, b.M)((0, D.C)((0, M.A)(E.Z)))))))),
        ),
      ) {
        constructor(...e) {
          super(...e),
            (this._handles = new y.Z()),
            (this.capabilities = null),
            (this.charts = null),
            (this.copyright = null),
            (this.displayField = null),
            (this.definitionExpression = null),
            (this.dynamicDataSource = null),
            (this.editFieldsInfo = null),
            (this.editingInfo = null),
            (this.elevationInfo = null),
            (this.featureReduction = null),
            (this.fields = null),
            (this.fieldsIndex = null),
            (this.floorInfo = null),
            (this.formTemplate = null),
            (this.fullExtent = null),
            (this.gdbVersion = null),
            (this.geometryFieldsInfo = null),
            (this.geometryType = null),
            (this.hasM = void 0),
            (this.hasZ = void 0),
            (this.heightModelInfo = null),
            (this.historicMoment = null),
            (this.infoFor3D = null),
            (this.isTable = !1),
            (this.labelsVisible = !0),
            (this.labelingInfo = null),
            (this.layerId = void 0),
            (this.legendEnabled = !0),
            (this.minScale = 0),
            (this.maxScale = 0),
            (this.globalIdField = null),
            (this.objectIdField = null),
            (this.outFields = null),
            (this.path = null),
            (this.popupEnabled = !0),
            (this.popupTemplate = null),
            (this.relationships = null),
            (this.sourceJSON = null),
            (this.returnM = void 0),
            (this.returnZ = void 0),
            (this.screenSizePerspectiveEnabled = !0),
            (this.serviceDefinitionExpression = null),
            (this.spatialReference = T.Z.WGS84),
            (this.subtypeCode = null),
            (this.templates = null),
            (this.timeInfo = null),
            (this.title = null),
            (this.sublayerTitleMode = 'item-title'),
            (this.trackIdField = null),
            (this.type = 'feature'),
            (this.typeIdField = null),
            (this.types = null),
            (this.indexes = new (u.Z.ofType(R.F))()),
            (this.userIsAdmin = !1),
            (this.version = void 0),
            (this.visible = !0);
        }
        destroy() {
          var e;
          null == (e = this.source) || e.destroy(), (this._handles = (0, c.j)(this._handles));
        }
        normalizeCtorArgs(e, t) {
          return 'string' == typeof e ? { url: e, ...t } : e;
        }
        load(e) {
          const t = (0, c.i)(e) ? e.signal : null;
          if (this.portalItem && this.portalItem.loaded && this.source)
            return void this.addResolvingPromise(
              this.createGraphicsSource(t).then((e) => this._initLayerProperties(e)),
            );
          const r = this.loadFromPortal(
            { supportedTypes: ['Feature Service', 'Feature Collection'] },
            e,
          )
            .catch(g.r9)
            .then(async () => {
              if (
                this.url &&
                null == this.layerId &&
                /FeatureServer|MapServer\/*$/i.test(this.url)
              ) {
                const e = await this._fetchFirstLayerId(t);
                null != e && (this.layerId = e);
              }
              if (!this.url && !this._hasMemorySource())
                throw new d.Z(
                  'feature-layer:missing-url-or-source',
                  'Feature layer must be created with either a url or a source',
                );
              return this._initLayerProperties(await this.createGraphicsSource(t));
            })
            .then(() => this.finishLoadEditablePortalLayer(e));
          return this.addResolvingPromise(r), Promise.resolve(this);
        }
        readCapabilities(e, t) {
          return (
            (t = t.layerDefinition || t),
            {
              attachment: this._readAttachmentCapabilities(t.attachmentProperties),
              data: this._readDataCapabilities(t),
              metadata: this._readMetadataCapabilities(t),
              operations: this._readOperationsCapabilities(t.capabilities || e, t),
              query: this._readQueryCapabilities(t),
              queryRelated: this._readQueryRelatedCapabilities(t),
              editing: this._readEditingCapabilities(t),
            }
          );
        }
        get createQueryVersion() {
          return (
            this.commitProperty('definitionExpression'),
            this.commitProperty('dynamicDataSource'),
            this.commitProperty('timeExtent'),
            this.commitProperty('timeOffset'),
            this.commitProperty('geometryType'),
            this.commitProperty('gdbVersion'),
            this.commitProperty('historicMoment'),
            this.commitProperty('returnZ'),
            this.commitProperty('capabilities'),
            this.commitProperty('returnM'),
            (this._get('createQueryVersion') || 0) + 1
          );
        }
        get editingEnabled() {
          return this._isOverridden('editingEnabled')
            ? this._get('editingEnabled')
            : this._hasMemorySource() || this.userHasEditingPrivileges;
        }
        set editingEnabled(e) {
          null != e ? this._override('editingEnabled', e) : this._clearOverride('editingEnabled');
        }
        readEditingEnabled(e, t) {
          return this._readEditingEnabled(t, !1);
        }
        readEditingEnabledFromWebMap(e, t, r) {
          return this._readEditingEnabled(t, !0, r);
        }
        writeEditingEnabled(e, t) {
          this._writeEditingEnabled(e, t, !1);
        }
        writeEditingEnabledToWebMap(e, t, r, i) {
          this._writeEditingEnabled(e, t, !0, i);
        }
        readEditingInfo(e, t) {
          const { editingInfo: r } = t;
          return r
            ? { lastEditDate: null != r.lastEditDate ? new Date(r.lastEditDate) : null }
            : null;
        }
        readFeatureReduction(e, t) {
          return (0, B.r)(e, t);
        }
        writeWebSceneFeatureReduction(e, t, r, i) {
          (0, B.w)(e, t, 'layerDefinition.featureReduction', i);
        }
        readIsTable(e, t) {
          return 'Table' === (t = (t && t.layerDefinition) || t).type || !t.geometryType;
        }
        writeIsTable(e, t, r, i) {
          null != i && i.writeLayerSchema && (0, f.s)(r, e ? 'Table' : 'Feature Layer', t);
        }
        readMinScale(e, t) {
          return t.effectiveMinScale || e || 0;
        }
        readMaxScale(e, t) {
          return t.effectiveMaxScale || e || 0;
        }
        readGlobalIdFieldFromService(e, t) {
          if ((t = t.layerDefinition || t).globalIdField) return t.globalIdField;
          if (t.fields)
            for (const e of t.fields) if ('esriFieldTypeGlobalID' === e.type) return e.name;
        }
        readObjectIdFieldFromService(e, t) {
          if ((t = t.layerDefinition || t).objectIdField) return t.objectIdField;
          if (t.fields) for (const e of t.fields) if ('esriFieldTypeOID' === e.type) return e.name;
        }
        get parsedUrl() {
          const e = this.url ? (0, w.mN)(this.url) : null;
          return (
            null != e &&
              (null != this.dynamicDataSource
                ? (e.path = (0, w.v_)(e.path, 'dynamicLayer'))
                : null != this.layerId && (e.path = (0, w.v_)(e.path, this.layerId.toString()))),
            e
          );
        }
        get defaultPopupTemplate() {
          return this.createPopupTemplate();
        }
        set renderer(e) {
          (0, z.YN)(e, this.fieldsIndex), this._set('renderer', e);
        }
        readRenderer(e, t, r) {
          const i = ((t = t.layerDefinition || t).drawingInfo && t.drawingInfo.renderer) || void 0;
          if (i) {
            const e = (0, a.ij)(i, t, r) || void 0;
            return (
              e ||
                ye.error('Failed to create renderer', {
                  rendererDefinition: t.drawingInfo.renderer,
                  layer: this,
                  context: r,
                }),
              e
            );
          }
          if (t.defaultSymbol)
            return t.types && t.types.length
              ? new n.Z({
                  defaultSymbol: we(t.defaultSymbol, t, r),
                  field: t.typeIdField,
                  uniqueValueInfos: t.types.map((e) => ({ id: e.id, symbol: we(e.symbol, e, r) })),
                })
              : new s.Z({ symbol: we(t.defaultSymbol, t, r) });
        }
        set source(e) {
          const t = this._get('source');
          t !== e &&
            (ce(t) && this._resetMemorySource(t),
            ce(e) && this._initMemorySource(e),
            this._set('source', e));
        }
        castSource(e) {
          return e
            ? Array.isArray(e) || e instanceof u.Z
              ? new R.M({ layer: this, items: e })
              : e
            : null;
        }
        readSource(e, t) {
          const r = oe.default.fromJSON(t.featureSet);
          return new R.M({ layer: this, items: (r && r.features) || [] });
        }
        readServiceDefinitionExpression(e, t) {
          return t.definitionQuery || t.definitionExpression;
        }
        readTemplates(e, t) {
          const r = t.editFieldsInfo,
            i = r && r.creatorField,
            o = r && r.editorField;
          return (
            (e = e && e.map((e) => U.Z.fromJSON(e))),
            this._fixTemplates(e, i),
            this._fixTemplates(e, o),
            e
          );
        }
        readTitle(e, t) {
          const r = (t.layerDefinition && t.layerDefinition.name) || t.name,
            i = t.title || (t.layerDefinition && t.layerDefinition.title);
          if (r) {
            const e = this.portalItem && this.portalItem.title;
            if ('item-title' === this.sublayerTitleMode)
              return this.url ? (0, G.t)(this.url, r) : r;
            let t = r;
            if (!t && this.url) {
              const e = (0, G.p)(this.url);
              (0, c.i)(e) && (t = e.title);
            }
            if (!t) return;
            return (
              'item-title-and-service-name' === this.sublayerTitleMode &&
                e &&
                e !== t &&
                (t = e + ' - ' + t),
              (0, G.c)(t)
            );
          }
          if ('item-title' === this.sublayerTitleMode && i) return i;
        }
        readTitleFromWebMap(e, t) {
          return t.title || (t.layerDefinition && t.layerDefinition.name);
        }
        readTypeIdField(e, t) {
          let r = (t = t.layerDefinition || t).typeIdField;
          if (r && t.fields) {
            r = r.toLowerCase();
            const e = t.fields.find((e) => e.name.toLowerCase() === r);
            e && (r = e.name);
          }
          return r;
        }
        readTypes(e, t) {
          e = (t = t.layerDefinition || t).types;
          const r = t.editFieldsInfo,
            i = r && r.creatorField,
            o = r && r.editorField;
          return (
            e &&
            e.map(
              (e) => (
                (e = W.Z.fromJSON(e)),
                this._fixTemplates(e.templates, i),
                this._fixTemplates(e.templates, o),
                e
              ),
            )
          );
        }
        set url(e) {
          const t = (0, G.a)({ layer: this, url: e, nonStandardUrlAllowed: !0, logger: ye });
          this._set('url', t.url), null != t.layerId && this._set('layerId', t.layerId);
        }
        writeUrl(e, t, r, i) {
          (0, G.w)(this, e, null, t, i);
        }
        readVersion(e, t) {
          return t.currentVersion
            ? t.currentVersion
            : t.hasOwnProperty('capabilities') ||
              t.hasOwnProperty('drawingInfo') ||
              t.hasOwnProperty('hasAttachments') ||
              t.hasOwnProperty('htmlPopupType') ||
              t.hasOwnProperty('relationships') ||
              t.hasOwnProperty('timeInfo') ||
              t.hasOwnProperty('typeIdField') ||
              t.hasOwnProperty('types')
            ? 10
            : 9.3;
        }
        readVisible(e, t) {
          return t.layerDefinition && null != t.layerDefinition.defaultVisibility
            ? !!t.layerDefinition.defaultVisibility
            : null != t.visibility
            ? !!t.visibility
            : void 0;
        }
        addAttachment(e, t) {
          return this.load()
            .then(() => this._checkAttachmentSupport(e))
            .then(() => {
              if (!('addAttachment' in this.source))
                throw new d.Z(de, 'Layer source does not support addAttachment capability');
              return this.source.addAttachment(e, t);
            });
        }
        updateAttachment(e, t, r) {
          return this.load()
            .then(() => this._checkAttachmentSupport(e))
            .then(() => {
              if (!('updateAttachment' in this.source))
                throw new d.Z(de, 'Layer source does not support updateAttachment capability');
              return this.source.updateAttachment(e, t, r);
            });
        }
        async applyEdits(e, t) {
          const i = await r.e(9231).then(r.bind(r, 89231));
          return await this.load(), i.applyEdits(this, this.source, e, t);
        }
        on(e, t) {
          return super.on(e, t);
        }
        createPopupTemplate(e) {
          return (0, le.eZ)(this, e);
        }
        async createGraphicsSource(e) {
          if (this._hasMemorySource()) return this.source.load({ signal: e });
          const { default: t } = await (0, g.Hl)(
            Promise.all([r.e(5528), r.e(1348)]).then(r.bind(r, 21348)),
            e,
          );
          return new t({ layer: this }).load({ signal: e });
        }
        createQuery() {
          const e = new se.Z(),
            t = this.get('capabilities.data');
          (e.dynamicDataSource = this.dynamicDataSource),
            (e.gdbVersion = this.gdbVersion),
            (e.historicMoment = this.historicMoment),
            (e.returnGeometry = !0),
            t &&
              (t.supportsZ && null != this.returnZ && (e.returnZ = this.returnZ),
              t.supportsM && null != this.returnM && (e.returnM = this.returnM)),
            (e.outFields = ['*']),
            (e.where = this.definitionExpression || '1=1');
          const { timeOffset: r, timeExtent: i } = this;
          return (
            (e.timeExtent = null != r && null != i ? i.offset(-r.value, r.unit) : i || null),
            (e.multipatchOption = 'multipatch' === this.geometryType ? 'xyFootprint' : null),
            e
          );
        }
        deleteAttachments(e, t) {
          return this.load()
            .then(() => this._checkAttachmentSupport(e))
            .then(() => {
              if (!('deleteAttachments' in this.source))
                throw new d.Z(de, 'Layer source does not support deleteAttachments capability');
              return this.source.deleteAttachments(e, t);
            });
        }
        fetchRecomputedExtents(e) {
          return this.load({ signal: null == e ? void 0 : e.signal }).then(() => {
            if (this.source.fetchRecomputedExtents) return this.source.fetchRecomputedExtents(e);
            throw new d.Z(de, 'Layer source does not support fetchUpdates capability');
          });
        }
        getFeatureType(e) {
          const { typeIdField: t, types: r } = this;
          if (!t || !e) return null;
          const i = e.attributes ? e.attributes[t] : void 0;
          if (null == i) return null;
          let o = null;
          return (
            r.some((e) => {
              const { id: t } = e;
              return null != t && (t.toString() === i.toString() && (o = e), !!o);
            }),
            o
          );
        }
        getFieldDomain(e, t) {
          const r = t && t.feature,
            i = this.getFeatureType(r);
          if (i) {
            const t = i.domains && i.domains[e];
            if (t && 'inherited' !== t.type) return t;
          }
          return this._getLayerDomain(e);
        }
        getField(e) {
          return this.fieldsIndex.get(e);
        }
        queryAttachments(e, t) {
          return (
            (e = ie.Z.from(e)),
            this.load().then(() => {
              if (!this.get('capabilities.data.supportsAttachment'))
                throw new d.Z(de, "this layer doesn't support attachments");
              const {
                attachmentTypes: t,
                objectIds: r,
                globalIds: i,
                num: o,
                size: s,
                start: n,
                where: a,
              } = e;
              if (!this.get('capabilities.operations.supportsQueryAttachments')) {
                const l = r && r.length > 1,
                  p = t && t.length,
                  u = i && i.length,
                  y = s && s.length;
                if (l || p || u || y || o || n || a)
                  throw new d.Z(
                    de,
                    "when 'supportsQueryAttachments' is false, only objectIds of length 1 are supported",
                    e,
                  );
              }
              if (!((r && r.length) || a))
                throw new d.Z(
                  de,
                  "'objectIds' or 'where' are required to perform attachment query",
                  e,
                );
              if (!('queryAttachments' in this.source))
                throw new d.Z(de, 'Layer source does not support queryAttachments capability', e);
              return this.source.queryAttachments(e);
            })
          );
        }
        queryFeatures(e, t) {
          return this.load()
            .then(() => this.source.queryFeatures(se.Z.from(e) || this.createQuery(), t))
            .then((e) => {
              if (null != e && e.features)
                for (const t of e.features) t.layer = t.sourceLayer = this;
              return e;
            });
        }
        queryObjectIds(e, t) {
          return this.load().then(() => {
            if (this.source.queryObjectIds)
              return this.source.queryObjectIds(se.Z.from(e) || this.createQuery(), t);
            throw new d.Z(de, 'Layer source does not support queryObjectIds capability');
          });
        }
        queryFeatureCount(e, t) {
          return this.load().then(() => {
            if (this.source.queryFeatureCount)
              return this.source.queryFeatureCount(se.Z.from(e) || this.createQuery(), t);
            throw new d.Z(de, 'Layer source does not support queryFeatureCount capability');
          });
        }
        queryExtent(e, t) {
          return this.load().then(() => {
            if (this.source.queryExtent)
              return this.source.queryExtent(se.Z.from(e) || this.createQuery(), t);
            throw new d.Z(de, 'Layer source does not support queryExtent capability');
          });
        }
        queryRelatedFeatures(e, t) {
          return this.load().then(() => {
            if ('queryRelatedFeatures' in this.source)
              return this.source.queryRelatedFeatures(ne.Z.from(e), t);
            throw new d.Z(de, 'Layer source does not support queryRelatedFeatures capability');
          });
        }
        queryRelatedFeaturesCount(e, t) {
          return this.load().then(() => {
            if ('queryRelatedFeaturesCount' in this.source)
              return this.source.queryRelatedFeaturesCount(ne.Z.from(e), t);
            throw new d.Z(de, 'Layer source does not support queryRelatedFeaturesCount capability');
          });
        }
        queryTopFeatures(e, t) {
          return this.load().then(() => {
            if (
              'queryTopFeatures' in this.source &&
              this.get('capabilities.query.supportsTopFeaturesQuery')
            )
              return this.source.queryTopFeatures(ae.Z.from(e), t).then((e) => {
                if (null != e && e.features)
                  for (const t of e.features) t.layer = t.sourceLayer = this;
                return e;
              });
            throw new d.Z(de, 'Layer source does not support queryTopFeatures capability');
          });
        }
        queryTopObjectIds(e, t) {
          return this.load().then(() => {
            if (
              'queryTopObjectIds' in this.source &&
              this.get('capabilities.query.supportsTopFeaturesQuery')
            )
              return this.source.queryTopObjectIds(ae.Z.from(e), t);
            throw new d.Z(de, 'Layer source does not support queryTopObjectIds capability');
          });
        }
        queryTopFeaturesExtent(e, t) {
          return this.load().then(() => {
            if (
              'queryTopExtents' in this.source &&
              this.get('capabilities.query.supportsTopFeaturesQuery')
            )
              return this.source.queryTopExtents(ae.Z.from(e), t);
            throw new d.Z(de, 'Layer source does not support queryTopExtents capability');
          });
        }
        queryTopFeatureCount(e, t) {
          return this.load().then(() => {
            if (
              'queryTopCount' in this.source &&
              this.get('capabilities.query.supportsTopFeaturesQuery')
            )
              return this.source.queryTopCount(ae.Z.from(e), t);
            throw new d.Z(de, 'Layer source does not support queryFeatureCount capability');
          });
        }
        read(e, t) {
          const r = e.featureCollection;
          if (r) {
            const e = r.layers;
            e &&
              1 === e.length &&
              (super.read(e[0], t),
              null != r.showLegend && super.read({ showLegend: r.showLegend }, t));
          }
          super.read(e, t),
            t &&
              'service' === t.origin &&
              this.revert(['objectIdField', 'fields', 'timeInfo', 'spatialReference'], 'service');
        }
        write(e, t) {
          var r, i;
          const o = (t = {
              ...t,
              writeLayerSchema:
                null != (r = null == (i = t) ? void 0 : i.writeLayerSchema)
                  ? r
                  : this._hasMemorySource(),
            }).origin,
            s = t.layerContainerType,
            n = t.messages;
          if (this.isTable) {
            if ('web-scene' === o || ('web-map' === o && 'tables' !== s))
              return (
                n &&
                  n.push(
                    new d.Z(
                      'layer:unsupported',
                      `Layer (${this.title}, ${this.id}) of type '${this.declaredClass}' using a Table source cannot be written to web scenes and web maps`,
                      { layer: this },
                    ),
                  ),
                null
              );
            if (this._hasMemorySource())
              return (
                n &&
                  n.push(
                    new d.Z(
                      'layer:unsupported',
                      `Layer (${this.title}, ${this.id}) of type '${this.declaredClass}' using an in-memory Table source cannot be written to web scenes and web maps`,
                      { layer: this },
                    ),
                  ),
                null
              );
          } else if (this.loaded && 'web-map' === o && 'tables' === s)
            return (
              n &&
                n.push(
                  new d.Z(
                    'layer:unsupported',
                    `Layer (${this.title}, ${this.id}) of type '${this.declaredClass}' using a non-table source cannot be written to tables in web maps`,
                    { layer: this },
                  ),
                ),
              null
            );
          return super.write(e, t);
        }
        _readEditingEnabled(e, t, r) {
          var i;
          let o = null == (i = e.layerDefinition) ? void 0 : i.capabilities;
          return o
            ? this._hasEditingCapability(o)
            : ((o = e.capabilities),
              t && 'web-map' === (null == r ? void 0 : r.origin) && !this._hasMemorySource() && o
                ? this._hasEditingCapability(o)
                : void 0);
        }
        _hasEditingCapability(e) {
          return e
            .toLowerCase()
            .split(',')
            .map((e) => e.trim())
            .includes('editing');
        }
        _writeEditingEnabled(e, t, r, i) {
          if (!e) {
            var o, s;
            const e =
              null != (o = this.capabilities) && null != (s = o.operations) && s.supportsSync
                ? 'Query,Sync'
                : 'Query';
            (0, f.s)('layerDefinition.capabilities', e, t),
              !r || (null != i && i.writeLayerSchema) || (t.capabilities = e);
          }
        }
        _checkAttachmentSupport(e) {
          const { attributes: t } = e,
            { objectIdField: r } = this;
          return this.get('capabilities.data.supportsAttachment')
            ? e
              ? t
                ? t[r]
                  ? void 0
                  : Promise.reject(new d.Z(de, `feature is missing the identifying attribute ${r}`))
                : Promise.reject(
                    new d.Z(de, "'attributes' are required on a feature to query attachments"),
                  )
              : Promise.reject(
                  new d.Z(de, 'A feature is required to add/delete/update attachments'),
                )
            : Promise.reject(new d.Z(de, "this layer doesn't support attachments"));
        }
        _getLayerDomain(e) {
          const t = this.fieldsIndex.get(e);
          return t ? t.domain : null;
        }
        _fetchFirstLayerId(e) {
          return (0, l.default)(this.url, {
            query: { f: 'json', ...this.customParameters, token: this.apiKey },
            responseType: 'json',
            signal: e,
          }).then((e) => {
            const t = e.data;
            if (t)
              return Array.isArray(t.layers) && t.layers.length > 0
                ? t.layers[0].id
                : Array.isArray(t.tables) && t.tables.length > 0
                ? t.tables[0].id
                : void 0;
          });
        }
        async _initLayerProperties(e) {
          return (
            this._set('source', e),
            e.sourceJSON &&
              ((this.sourceJSON = e.sourceJSON),
              this.read(e.sourceJSON, { origin: 'service', url: this.parsedUrl })),
            this._verifySource(),
            this._verifyFields(),
            (0, z.YN)(this.renderer, this.fieldsIndex),
            (0, z.UF)(this.timeInfo, this.fieldsIndex),
            (0, re.l)(this, { origin: 'service' })
          );
        }
        _verifyFields() {
          const e = (this.parsedUrl && this.parsedUrl.path) || 'undefined';
          this.objectIdField ||
            console.log("FeatureLayer: 'objectIdField' property is not defined (url: " + e + ')'),
            this.isTable ||
              this._hasMemorySource() ||
              -1 !== e.search(/\/FeatureServer\//i) ||
              (this.fields &&
                this.fields.some(function (e) {
                  return 'geometry' === e.type;
                })) ||
              console.log(
                "FeatureLayer: unable to find field of type 'geometry' in the layer 'fields' list. If you are using a map service layer, features will not have geometry (url: " +
                  e +
                  ')',
              );
        }
        _fixTemplates(e, t) {
          e &&
            e.forEach((e) => {
              const r = e.prototype && e.prototype.attributes;
              r && t && delete r[t];
            });
        }
        _verifySource() {
          if (this._hasMemorySource()) {
            if (this.url)
              throw new d.Z(
                'feature-layer:mixed-source-and-url',
                'FeatureLayer cannot be created with both an in-memory source and a url',
              );
          } else if (!this.url)
            throw new d.Z(
              'feature-layer:source-or-url-required',
              'FeatureLayer requires either a url, a valid portal item or a source',
            );
        }
        _initMemorySource(e) {
          e.forEach((e) => {
            (e.layer = this), (e.sourceLayer = this);
          }),
            this._handles.add(
              [
                e.on('after-add', (e) => {
                  (e.item.layer = this), (e.item.sourceLayer = this);
                }),
                e.on('after-remove', (e) => {
                  (e.item.layer = null), (e.item.sourceLayer = null);
                }),
              ],
              'fl-source',
            );
        }
        _resetMemorySource(e) {
          e.forEach((e) => {
            (e.layer = null), (e.sourceLayer = null);
          }),
            this._handles.remove('fl-source');
        }
        _hasMemorySource() {
          return !(this.url || !this.source);
        }
        _readAttachmentCapabilities(e) {
          const t = {
            supportsName: !1,
            supportsSize: !1,
            supportsContentType: !1,
            supportsKeywords: !1,
            supportsExifInfo: !1,
          };
          return (
            e &&
              Array.isArray(e) &&
              e.forEach((e) => {
                const r = ue[e.name];
                r && (t[r] = !!e.isEnabled);
              }),
            t
          );
        }
        _readDataCapabilities(e) {
          return {
            isVersioned: he(e, 'isDataVersioned', !1),
            supportsAttachment: he(e, 'hasAttachments', !1),
            supportsM: he(e, 'hasM', !1),
            supportsZ: he(e, 'hasZ', !1),
          };
        }
        _readMetadataCapabilities(e) {
          return { supportsAdvancedFieldProperties: he(e, 'supportsFieldDescriptionProperty', !1) };
        }
        _readOperationsCapabilities(e, t) {
          const r = e
              ? e
                  .toLowerCase()
                  .split(',')
                  .map((e) => e.trim())
              : [],
            i = -1 !== r.indexOf('editing');
          let o = i && -1 !== r.indexOf('create'),
            s = i && -1 !== r.indexOf('delete'),
            n = i && -1 !== r.indexOf('update');
          const a = -1 !== r.indexOf('changetracking');
          return (
            i && !(o || s || n) && (o = s = n = !0),
            {
              supportsCalculate: he(t, 'supportsCalculate', !1),
              supportsTruncate: he(t, 'supportsTruncate', !1),
              supportsValidateSql: he(t, 'supportsValidateSql', !1),
              supportsAdd: o,
              supportsDelete: s,
              supportsEditing: i,
              supportsChangeTracking: a,
              supportsQuery: -1 !== r.indexOf('query'),
              supportsQueryAttachments: he(
                t.advancedQueryCapabilities,
                'supportsQueryAttachments',
                !1,
              ),
              supportsResizeAttachments: he(t, 'supportsAttachmentsResizing', !1),
              supportsSync: -1 !== r.indexOf('sync'),
              supportsUpdate: n,
              supportsExceedsLimitStatistics: he(t, 'supportsExceedsLimitStatistics', !1),
            }
          );
        }
        _readQueryCapabilities(e) {
          var t;
          const r = e.advancedQueryCapabilities,
            i = e.ownershipBasedAccessControlForFeatures,
            o = e.archivingInfo,
            s = null == (t = this.url) ? void 0 : t.includes('MapServer'),
            n = !(0, c.h)('mapserver-pbf-enabled') && s && this.version < 10.81,
            a = (e.supportedQueryFormats || '').split(',').reduce((e, t) => {
              const r = t.toLowerCase().trim();
              return r && e.add(r), e;
            }, new Set());
          return {
            supportsStatistics: he(r, 'supportsStatistics', e.supportsStatistics),
            supportsPercentileStatistics: he(r, 'supportsPercentileStatistics', !1),
            supportsCentroid: he(r, 'supportsReturningGeometryCentroid', !1),
            supportsDistance: he(r, 'supportsQueryWithDistance', !1),
            supportsDistinct: he(r, 'supportsDistinct', e.supportsAdvancedQueries),
            supportsExtent: he(r, 'supportsReturningQueryExtent', !1),
            supportsGeometryProperties: he(r, 'supportsReturningGeometryProperties', !1),
            supportsHavingClause: he(r, 'supportsHavingClause', !1),
            supportsOrderBy: he(r, 'supportsOrderBy', e.supportsAdvancedQueries),
            supportsPagination: he(r, 'supportsPagination', !1),
            supportsQuantization: he(e, 'supportsCoordinatesQuantization', !1),
            supportsQuantizationEditMode: he(e, 'supportsQuantizationEditMode', !1),
            supportsQueryGeometry: he(e, 'supportsReturningQueryGeometry', !1),
            supportsResultType: he(r, 'supportsQueryWithResultType', !1),
            supportsMaxRecordCountFactor: he(r, 'supportsMaxRecordCountFactor', !1),
            supportsSqlExpression: he(r, 'supportsSqlExpression', !1),
            supportsStandardizedQueriesOnly: he(e, 'useStandardizedQueries', !1),
            supportsTopFeaturesQuery: he(r, 'supportsTopFeaturesQuery', !1),
            supportsQueryByOthers: he(i, 'allowOthersToQuery', !0),
            supportsHistoricMoment: he(o, 'supportsQueryWithHistoricMoment', !1),
            supportsFormatPBF: !n && a.has('pbf'),
            supportsDisjointSpatialRelationship: he(r, 'supportsDisjointSpatialRel', !1),
            supportsCacheHint: he(r, 'supportsQueryWithCacheHint', !1),
            maxRecordCountFactor: me(e, 'maxRecordCountFactor', void 0),
            maxRecordCount: me(e, 'maxRecordCount', void 0),
            standardMaxRecordCount: me(e, 'standardMaxRecordCount', void 0),
            tileMaxRecordCount: me(e, 'tileMaxRecordCount', void 0),
          };
        }
        _readQueryRelatedCapabilities(e) {
          const t = e.advancedQueryCapabilities,
            r = he(t, 'supportsAdvancedQueryRelated', !1);
          return {
            supportsPagination: he(t, 'supportsQueryRelatedPagination', !1),
            supportsCount: r,
            supportsOrderBy: r,
          };
        }
        _readEditingCapabilities(e) {
          const t = e.ownershipBasedAccessControlForFeatures;
          return {
            supportsGeometryUpdate: he(e, 'allowGeometryUpdates', !0),
            supportsGlobalId: he(e, 'supportsApplyEditsWithGlobalIds', !1),
            supportsReturnServiceEditsInSourceSpatialReference: he(
              e,
              'supportsReturnServiceEditsInSourceSR',
              !1,
            ),
            supportsRollbackOnFailure: he(e, 'supportsRollbackOnFailureParameter', !1),
            supportsUpdateWithoutM: he(e, 'allowUpdateWithoutMValues', !1),
            supportsUploadWithItemId: he(e, 'supportsAttachmentsByUploadId', !1),
            supportsDeleteByAnonymous: he(t, 'allowAnonymousToDelete', !0),
            supportsDeleteByOthers: he(t, 'allowOthersToDelete', !0),
            supportsUpdateByAnonymous: he(t, 'allowAnonymousToUpdate', !0),
            supportsUpdateByOthers: he(t, 'allowOthersToUpdate', !0),
          };
        }
      };
      (0, i._)(
        [(0, v.Cb)({ readOnly: !0, json: { read: !1 } })],
        ge.prototype,
        'capabilities',
        void 0,
      ),
        (0, i._)(
          [
            (0, C.r)('service', 'capabilities', [
              'advancedQueryCapabilities',
              'allowGeometryUpdates',
              'allowUpdateWithoutMValues',
              'archivingInfo',
              'capabilities',
              'hasAttachments',
              'hasM',
              'hasZ',
              'maxRecordCount',
              'maxRecordCountFactor',
              'ownershipBasedAccessControlForFeatures',
              'standardMaxRecordCount',
              'supportedQueryFormats',
              'supportsAdvancedQueries',
              'supportsApplyEditsWithGlobalIds',
              'supportsAttachmentsByUploadId',
              'supportsAttachmentsResizing',
              'supportsCalculate',
              'supportsCoordinatesQuantization',
              'supportsExceedsLimitStatistics',
              'supportsFieldDescriptionProperty',
              'supportsQuantizationEditMode',
              'supportsRollbackOnFailureParameter',
              'supportsStatistics',
              'supportsTruncate',
              'supportsValidateSql',
              'tileMaxRecordCount',
              'useStandardizedQueries',
            ]),
          ],
          ge.prototype,
          'readCapabilities',
          null,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              json: { origins: { 'portal-item': { write: !0 }, 'web-map': { write: !0 } } },
            }),
          ],
          ge.prototype,
          'charts',
          void 0,
        ),
        (0, i._)([(0, v.Cb)({ readOnly: !0 })], ge.prototype, 'createQueryVersion', null),
        (0, i._)(
          [
            (0, v.Cb)({
              type: String,
              json: {
                read: { source: 'layerDefinition.copyrightText' },
                origins: { service: { read: { source: 'copyrightText' } } },
              },
            }),
          ],
          ge.prototype,
          'copyright',
          void 0,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              type: String,
              json: {
                read: { source: 'layerDefinition.displayField' },
                origins: { service: { read: { source: 'displayField' } } },
              },
            }),
          ],
          ge.prototype,
          'displayField',
          void 0,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              type: String,
              json: {
                origins: { service: { read: !1, write: !1 } },
                name: 'layerDefinition.definitionExpression',
                write: { enabled: !0, allowNull: !0 },
              },
            }),
          ],
          ge.prototype,
          'definitionExpression',
          void 0,
        ),
        (0, i._)([(0, v.Cb)({ types: p.LB, readOnly: !0 })], ge.prototype, 'defaultSymbol', void 0),
        (0, i._)([(0, v.Cb)({ type: te.D })], ge.prototype, 'dynamicDataSource', void 0),
        (0, i._)([(0, v.Cb)({ readOnly: !0 })], ge.prototype, 'editFieldsInfo', void 0),
        (0, i._)([(0, v.Cb)({ type: Boolean })], ge.prototype, 'editingEnabled', null),
        (0, i._)(
          [
            (0, C.r)(['portal-item', 'web-scene'], 'editingEnabled', [
              'layerDefinition.capabilities',
            ]),
          ],
          ge.prototype,
          'readEditingEnabled',
          null,
        ),
        (0, i._)(
          [(0, C.r)('web-map', 'editingEnabled', ['capabilities', 'layerDefinition.capabilities'])],
          ge.prototype,
          'readEditingEnabledFromWebMap',
          null,
        ),
        (0, i._)(
          [
            (0, F.w)(['portal-item', 'web-scene'], 'editingEnabled', {
              'layerDefinition.capabilities': { type: String },
            }),
          ],
          ge.prototype,
          'writeEditingEnabled',
          null,
        ),
        (0, i._)(
          [
            (0, F.w)('web-map', 'editingEnabled', {
              capabilities: { type: String },
              'layerDefinition.capabilities': { type: String },
            }),
          ],
          ge.prototype,
          'writeEditingEnabledToWebMap',
          null,
        ),
        (0, i._)([(0, v.Cb)({ readOnly: !0 })], ge.prototype, 'editingInfo', void 0),
        (0, i._)([(0, C.r)('editingInfo')], ge.prototype, 'readEditingInfo', null),
        (0, i._)([(0, v.Cb)(V.e)], ge.prototype, 'elevationInfo', void 0),
        (0, i._)(
          [
            (0, v.Cb)({
              types: { key: 'type', base: k.F, typeMap: { selection: k.Z, cluster: Q.Z } },
              json: { write: { target: 'layerDefinition.featureReduction' } },
            }),
          ],
          ge.prototype,
          'featureReduction',
          void 0,
        ),
        (0, i._)(
          [(0, C.r)('featureReduction', ['layerDefinition.featureReduction'])],
          ge.prototype,
          'readFeatureReduction',
          null,
        ),
        (0, i._)(
          [
            (0, F.w)('web-scene', 'featureReduction', {
              'layerDefinition.featureReduction': { types: B.a },
            }),
          ],
          ge.prototype,
          'writeWebSceneFeatureReduction',
          null,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              ...be.fields,
              json: {
                read: { source: 'layerDefinition.fields' },
                origins: {
                  service: { read: !0 },
                  'web-map': { write: { target: 'layerDefinition.fields', overridePolicy: fe } },
                },
              },
            }),
          ],
          ge.prototype,
          'fields',
          void 0,
        ),
        (0, i._)([(0, v.Cb)(be.fieldsIndex)], ge.prototype, 'fieldsIndex', void 0),
        (0, i._)(
          [
            (0, v.Cb)({
              type: Y.Z,
              json: {
                read: { source: 'layerDefinition.floorInfo' },
                write: { target: 'layerDefinition.floorInfo' },
              },
            }),
          ],
          ge.prototype,
          'floorInfo',
          void 0,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              type: j.Z,
              json: {
                name: 'formInfo',
                write: !0,
                origins: { 'web-scene': { read: !1, write: !1 } },
              },
            }),
          ],
          ge.prototype,
          'formTemplate',
          void 0,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              type: I.Z,
              json: {
                origins: { service: { read: { source: 'extent' } } },
                read: { source: 'layerDefinition.extent' },
              },
            }),
          ],
          ge.prototype,
          'fullExtent',
          void 0,
        ),
        (0, i._)([(0, v.Cb)()], ge.prototype, 'gdbVersion', void 0),
        (0, i._)(
          [
            (0, v.Cb)({
              readOnly: !0,
              type: H.Z,
              json: { read: { source: 'geometryProperties' } },
            }),
          ],
          ge.prototype,
          'geometryFieldsInfo',
          void 0,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              type: ['point', 'polygon', 'polyline', 'multipoint', 'multipatch', 'mesh'],
              json: {
                origins: {
                  service: { read: pe.read },
                  'web-map': {
                    write: {
                      target: 'layerDefinition.geometryType',
                      overridePolicy: fe,
                      writer(e, t, r) {
                        const i = e ? pe.toJSON(e) : null;
                        i && (0, f.s)(r, i, t);
                      },
                    },
                  },
                },
                read: { source: 'layerDefinition.geometryType', reader: pe.read },
              },
            }),
          ],
          ge.prototype,
          'geometryType',
          void 0,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              type: Boolean,
              json: {
                origins: { service: { read: !0 } },
                read: { source: 'layerDefinition.hasM' },
              },
            }),
          ],
          ge.prototype,
          'hasM',
          void 0,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              type: Boolean,
              json: {
                origins: { service: { read: !0 } },
                read: { source: 'layerDefinition.hasZ' },
              },
            }),
          ],
          ge.prototype,
          'hasZ',
          void 0,
        ),
        (0, i._)([(0, v.Cb)({ readOnly: !0, type: x.Z })], ge.prototype, 'heightModelInfo', void 0),
        (0, i._)([(0, v.Cb)({ type: Date })], ge.prototype, 'historicMoment', void 0),
        (0, i._)([(0, v.Cb)(V.i)], ge.prototype, 'id', void 0),
        (0, i._)(
          [(0, v.Cb)({ readOnly: !0, json: { origins: { service: { read: !0 } }, read: !1 } })],
          ge.prototype,
          'infoFor3D',
          void 0,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              readOnly: !0,
              json: { origins: { 'web-map': { write: { target: 'layerDefinition.type' } } } },
            }),
          ],
          ge.prototype,
          'isTable',
          void 0,
        ),
        (0, i._)(
          [
            (0, C.r)('service', 'isTable', ['type', 'geometryType']),
            (0, C.r)('isTable', ['layerDefinition.type', 'layerDefinition.geometryType']),
          ],
          ge.prototype,
          'readIsTable',
          null,
        ),
        (0, i._)([(0, F.w)('web-map', 'isTable')], ge.prototype, 'writeIsTable', null),
        (0, i._)([(0, v.Cb)(V.l)], ge.prototype, 'labelsVisible', void 0),
        (0, i._)(
          [
            (0, v.Cb)({
              type: [$.Z],
              json: {
                origins: {
                  service: {
                    read: { source: 'drawingInfo.labelingInfo', reader: K.r },
                    write: { target: 'drawingInfo.labelingInfo', enabled: !1 },
                  },
                },
                read: { source: 'layerDefinition.drawingInfo.labelingInfo', reader: K.r },
                write: { target: 'layerDefinition.drawingInfo.labelingInfo' },
              },
            }),
          ],
          ge.prototype,
          'labelingInfo',
          void 0,
        ),
        (0, i._)([(0, v.Cb)(V.a)], ge.prototype, 'opacity', void 0),
        (0, i._)(
          [
            (0, v.Cb)({
              type: Number,
              json: { origins: { service: { read: { source: 'id' } } }, read: !1 },
            }),
          ],
          ge.prototype,
          'layerId',
          void 0,
        ),
        (0, i._)([(0, v.Cb)(V.b)], ge.prototype, 'legendEnabled', void 0),
        (0, i._)([(0, v.Cb)({ type: ['show', 'hide'] })], ge.prototype, 'listMode', void 0),
        (0, i._)([(0, v.Cb)(V.m)], ge.prototype, 'minScale', void 0),
        (0, i._)(
          [(0, C.r)('service', 'minScale', ['minScale', 'effectiveMinScale'])],
          ge.prototype,
          'readMinScale',
          null,
        ),
        (0, i._)([(0, v.Cb)(V.c)], ge.prototype, 'maxScale', void 0),
        (0, i._)(
          [(0, C.r)('service', 'maxScale', ['maxScale', 'effectiveMaxScale'])],
          ge.prototype,
          'readMaxScale',
          null,
        ),
        (0, i._)([(0, v.Cb)({ type: String })], ge.prototype, 'globalIdField', void 0),
        (0, i._)(
          [
            (0, C.r)('globalIdField', ['layerDefinition.globalIdField', 'layerDefinition.fields']),
            (0, C.r)('service', 'globalIdField', ['globalIdField', 'fields']),
          ],
          ge.prototype,
          'readGlobalIdFieldFromService',
          null,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              type: String,
              json: {
                origins: {
                  'web-map': {
                    write: { target: 'layerDefinition.objectIdField', overridePolicy: fe },
                  },
                },
              },
            }),
          ],
          ge.prototype,
          'objectIdField',
          void 0,
        ),
        (0, i._)(
          [
            (0, C.r)('objectIdField', ['layerDefinition.objectIdField', 'layerDefinition.fields']),
            (0, C.r)('service', 'objectIdField', ['objectIdField', 'fields']),
          ],
          ge.prototype,
          'readObjectIdFieldFromService',
          null,
        ),
        (0, i._)(
          [(0, v.Cb)({ value: 'ArcGISFeatureLayer', type: ['ArcGISFeatureLayer'] })],
          ge.prototype,
          'operationalLayerType',
          void 0,
        ),
        (0, i._)([(0, v.Cb)(be.outFields)], ge.prototype, 'outFields', void 0),
        (0, i._)([(0, v.Cb)({ readOnly: !0 })], ge.prototype, 'parsedUrl', null),
        (0, i._)(
          [
            (0, v.Cb)({
              type: String,
              json: { origins: { 'web-scene': { read: !0, write: !0 } }, read: !1 },
            }),
          ],
          ge.prototype,
          'path',
          void 0,
        ),
        (0, i._)([(0, v.Cb)(V.p)], ge.prototype, 'popupEnabled', void 0),
        (0, i._)(
          [
            (0, v.Cb)({
              type: o.Z,
              json: { read: { source: 'popupInfo' }, write: { target: 'popupInfo' } },
            }),
          ],
          ge.prototype,
          'popupTemplate',
          void 0,
        ),
        (0, i._)([(0, v.Cb)({ readOnly: !0 })], ge.prototype, 'defaultPopupTemplate', null),
        (0, i._)([(0, v.Cb)({ type: [X.Z], readOnly: !0 })], ge.prototype, 'relationships', void 0),
        (0, i._)(
          [
            (0, v.Cb)({
              types: a.r,
              json: {
                origins: {
                  service: { write: { target: 'drawingInfo.renderer', enabled: !1 } },
                  'web-scene': {
                    types: a.w,
                    write: { target: 'layerDefinition.drawingInfo.renderer', writer: a.cW },
                  },
                },
                write: {
                  target: 'layerDefinition.drawingInfo.renderer',
                  overridePolicy: (e, t, r) => ({
                    ignoreOrigin: null == r ? void 0 : r.writeLayerSchema,
                  }),
                  writer: a.cW,
                },
              },
            }),
          ],
          ge.prototype,
          'renderer',
          null,
        ),
        (0, i._)(
          [
            (0, C.r)('service', 'renderer', ['drawingInfo.renderer', 'defaultSymbol']),
            (0, C.r)('renderer', [
              'layerDefinition.drawingInfo.renderer',
              'layerDefinition.defaultSymbol',
            ]),
          ],
          ge.prototype,
          'readRenderer',
          null,
        ),
        (0, i._)([(0, v.Cb)()], ge.prototype, 'sourceJSON', void 0),
        (0, i._)([(0, v.Cb)({ type: Boolean })], ge.prototype, 'returnM', void 0),
        (0, i._)([(0, v.Cb)({ type: Boolean })], ge.prototype, 'returnZ', void 0),
        (0, i._)([(0, v.Cb)(V.d)], ge.prototype, 'screenSizePerspectiveEnabled', void 0),
        (0, i._)([(0, v.Cb)()], ge.prototype, 'source', null),
        (0, i._)([(0, _.p)('source')], ge.prototype, 'castSource', null),
        (0, i._)(
          [
            (0, C.r)('portal-item', 'source', ['featureSet']),
            (0, C.r)('web-map', 'source', ['featureSet']),
          ],
          ge.prototype,
          'readSource',
          null,
        ),
        (0, i._)(
          [(0, v.Cb)({ readOnly: !0 })],
          ge.prototype,
          'serviceDefinitionExpression',
          void 0,
        ),
        (0, i._)(
          [
            (0, C.r)('service', 'serviceDefinitionExpression', [
              'definitionQuery',
              'definitionExpression',
            ]),
          ],
          ge.prototype,
          'readServiceDefinitionExpression',
          null,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              type: T.Z,
              json: {
                origins: { service: { read: { source: 'extent.spatialReference' } } },
                read: { source: 'layerDefinition.extent.spatialReference' },
              },
            }),
          ],
          ge.prototype,
          'spatialReference',
          void 0,
        ),
        (0, i._)([(0, v.Cb)({ type: Number })], ge.prototype, 'subtypeCode', void 0),
        (0, i._)([(0, v.Cb)({ type: [U.Z] })], ge.prototype, 'templates', void 0),
        (0, i._)(
          [(0, C.r)('templates', ['editFieldsInfo', 'creatorField', 'editorField', 'templates'])],
          ge.prototype,
          'readTemplates',
          null,
        ),
        (0, i._)([(0, v.Cb)({ type: ee.Z })], ge.prototype, 'timeInfo', void 0),
        (0, i._)([(0, v.Cb)()], ge.prototype, 'title', void 0),
        (0, i._)(
          [
            (0, C.r)('service', 'title', ['name']),
            (0, C.r)('portal-item', 'title', [
              'layerDefinition.title',
              'layerDefinition.name',
              'title',
            ]),
          ],
          ge.prototype,
          'readTitle',
          null,
        ),
        (0, i._)(
          [(0, C.r)('web-map', 'title', ['layerDefinition.name', 'title'])],
          ge.prototype,
          'readTitleFromWebMap',
          null,
        ),
        (0, i._)([(0, v.Cb)({ type: String })], ge.prototype, 'sublayerTitleMode', void 0),
        (0, i._)(
          [(0, v.Cb)({ type: String, json: { read: { source: 'timeInfo.trackIdField' } } })],
          ge.prototype,
          'trackIdField',
          void 0,
        ),
        (0, i._)([(0, v.Cb)({ json: { read: !1 } })], ge.prototype, 'type', void 0),
        (0, i._)([(0, v.Cb)({ type: String })], ge.prototype, 'typeIdField', void 0),
        (0, i._)(
          [
            (0, C.r)('service', 'typeIdField'),
            (0, C.r)('typeIdField', ['layerDefinition.typeIdField']),
          ],
          ge.prototype,
          'readTypeIdField',
          null,
        ),
        (0, i._)([(0, v.Cb)({ type: [W.Z] })], ge.prototype, 'types', void 0),
        (0, i._)(
          [(0, C.r)('service', 'types', ['types']), (0, C.r)('types', ['layerDefinition.types'])],
          ge.prototype,
          'readTypes',
          null,
        ),
        (0, i._)(
          [(0, v.Cb)({ readOnly: !0, json: { write: !1 } })],
          ge.prototype,
          'serverGens',
          void 0,
        ),
        (0, i._)(
          [(0, v.Cb)({ type: u.Z.ofType(R.F), readOnly: !0 })],
          ge.prototype,
          'indexes',
          void 0,
        ),
        (0, i._)([(0, v.Cb)(V.u)], ge.prototype, 'url', null),
        (0, i._)([(0, F.w)('url')], ge.prototype, 'writeUrl', null),
        (0, i._)([(0, v.Cb)({ readOnly: !0 })], ge.prototype, 'userIsAdmin', void 0),
        (0, i._)(
          [(0, v.Cb)({ json: { origins: { service: { read: !0 } }, read: !1 } })],
          ge.prototype,
          'version',
          void 0,
        ),
        (0, i._)(
          [
            (0, C.r)('service', 'version', [
              'currentVersion',
              'capabilities',
              'drawingInfo',
              'hasAttachments',
              'htmlPopupType',
              'relationships',
              'timeInfo',
              'typeIdField',
              'types',
            ]),
          ],
          ge.prototype,
          'readVersion',
          null,
        ),
        (0, i._)(
          [
            (0, v.Cb)({
              type: Boolean,
              json: {
                origins: {
                  'portal-item': { write: { target: 'layerDefinition.defaultVisibility' } },
                },
              },
            }),
          ],
          ge.prototype,
          'visible',
          void 0,
        ),
        (0, i._)(
          [(0, C.r)('portal-item', 'visible', ['visibility', 'layerDefinition.defaultVisibility'])],
          ge.prototype,
          'readVisible',
          null,
        ),
        (ge = (0, i._)([(0, S.j)('esri.layers.FeatureLayer')], ge));
      const we = (0, S.d)({ types: p.QT }),
        ve = ge;
    },
    17055: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => p });
      var i = r(29768),
        o = r(74673),
        s = r(53785),
        n = r(34250),
        a = (r(76506), r(91306), r(92143), r(17533));
      r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(81172),
        r(71552),
        r(31450),
        r(40642),
        r(26341),
        r(57251),
        r(95587),
        r(60947),
        r(2906),
        r(89623);
      let l = class extends o.a {
        constructor(e) {
          super(e),
            (this.shapeAreaField = null),
            (this.shapeLengthField = null),
            (this.units = null);
        }
      };
      (0, i._)(
        [(0, n.Cb)({ type: String, json: { read: { source: 'shapeAreaFieldName' } } })],
        l.prototype,
        'shapeAreaField',
        void 0,
      ),
        (0, i._)(
          [(0, n.Cb)({ type: String, json: { read: { source: 'shapeLengthFieldName' } } })],
          l.prototype,
          'shapeLengthField',
          void 0,
        ),
        (0, i._)(
          [(0, n.Cb)({ type: String, json: { read: (e) => s.e.read(e) || s.f.read(e) } })],
          l.prototype,
          'units',
          void 0,
        ),
        (l = (0, i._)([(0, a.j)('esri.layers.support.GeometryFieldsInfo')], l));
      const p = l;
    },
    2180: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => p });
      var i = r(29768),
        o = r(15324),
        s = r(74673),
        n = r(34250),
        a = (r(76506), r(91306), r(92143), r(17533));
      r(91055),
        r(76996),
        r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(81172),
        r(71552),
        r(31450),
        r(40642),
        r(26341);
      let l = class extends s.a {
        constructor(e) {
          super(e),
            (this.floorField = null),
            (this.viewAllMode = !1),
            (this.viewAllLevelIds = new o.Z());
        }
      };
      (0, i._)(
        [(0, n.Cb)({ type: String, json: { write: !0 } })],
        l.prototype,
        'floorField',
        void 0,
      ),
        (0, i._)(
          [(0, n.Cb)({ json: { read: !1, write: !1 } })],
          l.prototype,
          'viewAllMode',
          void 0,
        ),
        (0, i._)(
          [(0, n.Cb)({ json: { read: !1, write: !1 } })],
          l.prototype,
          'viewAllLevelIds',
          void 0,
        ),
        (l = (0, i._)([(0, a.j)('esri.layers.support.LayerFloorInfo')], l));
      const p = l;
    },
    14327: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => d });
      var i = r(29768),
        o = r(57251),
        s = r(74673),
        n = r(34250),
        a = (r(76506), r(91306), r(92143), r(17533));
      r(71552),
        r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(81172),
        r(31450),
        r(40642),
        r(26341);
      const l = new o.J({
          esriRelCardinalityOneToOne: 'one-to-one',
          esriRelCardinalityOneToMany: 'one-to-many',
          esriRelCardinalityManyToMany: 'many-to-many',
        }),
        p = new o.J({ esriRelRoleOrigin: 'origin', esriRelRoleDestination: 'destination' });
      let u = class extends s.a {
        constructor(e) {
          super(e),
            (this.cardinality = null),
            (this.composite = null),
            (this.id = null),
            (this.keyField = null),
            (this.keyFieldInRelationshipTable = null),
            (this.name = null),
            (this.relatedTableId = null),
            (this.relationshipTableId = null),
            (this.role = null);
        }
      };
      (0, i._)(
        [(0, n.Cb)({ json: { read: l.read, write: l.write } })],
        u.prototype,
        'cardinality',
        void 0,
      ),
        (0, i._)([(0, n.Cb)({ json: { read: !0, write: !0 } })], u.prototype, 'composite', void 0),
        (0, i._)([(0, n.Cb)({ json: { read: !0, write: !0 } })], u.prototype, 'id', void 0),
        (0, i._)([(0, n.Cb)({ json: { read: !0, write: !0 } })], u.prototype, 'keyField', void 0),
        (0, i._)(
          [(0, n.Cb)({ json: { read: !0, write: !0 } })],
          u.prototype,
          'keyFieldInRelationshipTable',
          void 0,
        ),
        (0, i._)([(0, n.Cb)({ json: { read: !0, write: !0 } })], u.prototype, 'name', void 0),
        (0, i._)(
          [(0, n.Cb)({ json: { read: !0, write: !0 } })],
          u.prototype,
          'relatedTableId',
          void 0,
        ),
        (0, i._)(
          [(0, n.Cb)({ json: { read: !0, write: !0 } })],
          u.prototype,
          'relationshipTableId',
          void 0,
        ),
        (0, i._)(
          [(0, n.Cb)({ json: { read: p.read, write: p.write } })],
          u.prototype,
          'role',
          void 0,
        ),
        (u = (0, i._)([(0, a.j)('esri.layers.support.Relationship')], u));
      const d = u;
    },
    34446: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => y });
      var i,
        o = r(29768),
        s = r(74673),
        n = r(76506),
        a = r(34250),
        l = r(91306),
        p = (r(92143), r(17533)),
        u = r(2906);
      r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(81172),
        r(71552),
        r(31450),
        r(40642),
        r(26341);
      let d = (i = class extends s.a {
        constructor(e) {
          super(e),
            (this.attachmentTypes = null),
            (this.attachmentsWhere = null),
            (this.keywords = null),
            (this.globalIds = null),
            (this.name = null),
            (this.num = null),
            (this.objectIds = null),
            (this.returnMetadata = !1),
            (this.size = null),
            (this.start = null),
            (this.where = null);
        }
        writeStart(e, t) {
          (t.resultOffset = this.start), (t.resultRecordCount = this.num || 10);
        }
        clone() {
          return new i(
            (0, n.d9)({
              attachmentTypes: this.attachmentTypes,
              attachmentsWhere: this.attachmentsWhere,
              keywords: this.keywords,
              where: this.where,
              globalIds: this.globalIds,
              name: this.name,
              num: this.num,
              objectIds: this.objectIds,
              returnMetadata: this.returnMetadata,
              size: this.size,
              start: this.start,
            }),
          );
        }
      });
      (0, o._)(
        [(0, a.Cb)({ type: [String], json: { write: !0 } })],
        d.prototype,
        'attachmentTypes',
        void 0,
      ),
        (0, o._)(
          [
            (0, a.Cb)({
              type: String,
              json: {
                read: { source: 'attachmentsDefinitionExpression' },
                write: { target: 'attachmentsDefinitionExpression' },
              },
            }),
          ],
          d.prototype,
          'attachmentsWhere',
          void 0,
        ),
        (0, o._)(
          [(0, a.Cb)({ type: [String], json: { write: !0 } })],
          d.prototype,
          'keywords',
          void 0,
        ),
        (0, o._)(
          [(0, a.Cb)({ type: [Number], json: { write: !0 } })],
          d.prototype,
          'globalIds',
          void 0,
        ),
        (0, o._)([(0, a.Cb)({ json: { write: !0 } })], d.prototype, 'name', void 0),
        (0, o._)(
          [(0, a.Cb)({ type: Number, json: { read: { source: 'resultRecordCount' } } })],
          d.prototype,
          'num',
          void 0,
        ),
        (0, o._)(
          [(0, a.Cb)({ type: [Number], json: { write: !0 } })],
          d.prototype,
          'objectIds',
          void 0,
        ),
        (0, o._)(
          [(0, a.Cb)({ type: Boolean, json: { default: !1, write: !0 } })],
          d.prototype,
          'returnMetadata',
          void 0,
        ),
        (0, o._)([(0, a.Cb)({ type: [Number], json: { write: !0 } })], d.prototype, 'size', void 0),
        (0, o._)(
          [(0, a.Cb)({ type: Number, json: { read: { source: 'resultOffset' } } })],
          d.prototype,
          'start',
          void 0,
        ),
        (0, o._)([(0, u.w)('start'), (0, u.w)('num')], d.prototype, 'writeStart', null),
        (0, o._)(
          [
            (0, a.Cb)({
              type: String,
              json: {
                read: { source: 'definitionExpression' },
                write: { target: 'definitionExpression' },
              },
            }),
          ],
          d.prototype,
          'where',
          void 0,
        ),
        (d = i = (0, o._)([(0, p.j)('esri.rest.support.AttachmentQuery')], d)),
        (d.from = (0, l.e)(d));
      const y = d;
    },
    46646: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => h });
      var i,
        o = r(29768),
        s = (r(74569), r(74673)),
        n = r(76506),
        a = r(34250),
        l = r(91306),
        p = (r(92143), r(17533)),
        u = r(2906),
        d = r(69218),
        y = r(60947);
      r(21801),
        r(40642),
        r(71552),
        r(73796),
        r(97714),
        r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(81172),
        r(31450),
        r(26341),
        r(91597),
        r(86787),
        r(35132),
        r(89623),
        r(84069),
        r(44567),
        r(98380),
        r(92896),
        r(22781),
        r(57251),
        r(32422),
        r(59465),
        r(97546),
        r(9801),
        r(53523),
        r(42911),
        r(46826),
        r(45433),
        r(54732);
      let c = (i = class extends s.a {
        constructor(e) {
          super(e),
            (this.dynamicDataSource = void 0),
            (this.gdbVersion = null),
            (this.geometryPrecision = void 0),
            (this.historicMoment = null),
            (this.maxAllowableOffset = void 0),
            (this.objectIds = null),
            (this.orderByFields = null),
            (this.outFields = null),
            (this.outSpatialReference = null),
            (this.relationshipId = void 0),
            (this.start = void 0),
            (this.num = void 0),
            (this.returnGeometry = !1),
            (this.returnM = void 0),
            (this.returnZ = void 0),
            (this.where = null);
        }
        _writeHistoricMoment(e, t) {
          t.historicMoment = e && e.getTime();
        }
        writeStart(e, t) {
          (t.resultOffset = this.start), (t.resultRecordCount = this.num || 10), (t.where = '1=1');
        }
        clone() {
          return new i(
            (0, n.d9)({
              dynamicDataSource: this.dynamicDataSource,
              gdbVersion: this.gdbVersion,
              geometryPrecision: this.geometryPrecision,
              historicMoment: this.historicMoment && new Date(this.historicMoment.getTime()),
              maxAllowableOffset: this.maxAllowableOffset,
              objectIds: this.objectIds,
              orderByFields: this.orderByFields,
              outFields: this.outFields,
              outSpatialReference: this.outSpatialReference,
              relationshipId: this.relationshipId,
              start: this.start,
              num: this.num,
              returnGeometry: this.returnGeometry,
              where: this.where,
              returnZ: this.returnZ,
              returnM: this.returnM,
            }),
          );
        }
      });
      (0, o._)(
        [(0, a.Cb)({ type: d.D, json: { write: !0 } })],
        c.prototype,
        'dynamicDataSource',
        void 0,
      ),
        (0, o._)(
          [(0, a.Cb)({ type: String, json: { write: !0 } })],
          c.prototype,
          'gdbVersion',
          void 0,
        ),
        (0, o._)(
          [(0, a.Cb)({ type: Number, json: { write: !0 } })],
          c.prototype,
          'geometryPrecision',
          void 0,
        ),
        (0, o._)([(0, a.Cb)({ type: Date })], c.prototype, 'historicMoment', void 0),
        (0, o._)([(0, u.w)('historicMoment')], c.prototype, '_writeHistoricMoment', null),
        (0, o._)(
          [(0, a.Cb)({ type: Number, json: { write: !0 } })],
          c.prototype,
          'maxAllowableOffset',
          void 0,
        ),
        (0, o._)(
          [(0, a.Cb)({ type: [Number], json: { write: !0 } })],
          c.prototype,
          'objectIds',
          void 0,
        ),
        (0, o._)(
          [(0, a.Cb)({ type: [String], json: { write: !0 } })],
          c.prototype,
          'orderByFields',
          void 0,
        ),
        (0, o._)(
          [(0, a.Cb)({ type: [String], json: { write: !0 } })],
          c.prototype,
          'outFields',
          void 0,
        ),
        (0, o._)(
          [
            (0, a.Cb)({
              type: y.Z,
              json: { read: { source: 'outSR' }, write: { target: 'outSR' } },
            }),
          ],
          c.prototype,
          'outSpatialReference',
          void 0,
        ),
        (0, o._)([(0, a.Cb)({ json: { write: !0 } })], c.prototype, 'relationshipId', void 0),
        (0, o._)(
          [(0, a.Cb)({ type: Number, json: { read: { source: 'resultOffset' } } })],
          c.prototype,
          'start',
          void 0,
        ),
        (0, o._)([(0, u.w)('start'), (0, u.w)('num')], c.prototype, 'writeStart', null),
        (0, o._)(
          [(0, a.Cb)({ type: Number, json: { read: { source: 'resultRecordCount' } } })],
          c.prototype,
          'num',
          void 0,
        ),
        (0, o._)([(0, a.Cb)({ json: { write: !0 } })], c.prototype, 'returnGeometry', void 0),
        (0, o._)(
          [
            (0, a.Cb)({
              type: Boolean,
              json: { write: { overridePolicy: (e) => ({ enabled: e }) } },
            }),
          ],
          c.prototype,
          'returnM',
          void 0,
        ),
        (0, o._)(
          [
            (0, a.Cb)({
              type: Boolean,
              json: { write: { overridePolicy: (e) => ({ enabled: e }) } },
            }),
          ],
          c.prototype,
          'returnZ',
          void 0,
        ),
        (0, o._)(
          [
            (0, a.Cb)({
              type: String,
              json: {
                read: { source: 'definitionExpression' },
                write: { target: 'definitionExpression' },
              },
            }),
          ],
          c.prototype,
          'where',
          void 0,
        ),
        (c = i = (0, o._)([(0, p.j)('esri.rest.support.RelationshipQuery')], c)),
        (c.from = (0, l.e)(c));
      const h = c;
    },
    39210: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => v });
      var i,
        o = r(29768),
        s = r(74569),
        n = r(93314),
        a = r(57251),
        l = r(74673),
        p = r(76506),
        u = r(34250),
        d = r(91306),
        y = (r(92143), r(17533)),
        c = r(2906),
        h = r(32422),
        m = r(90549),
        b = r(60947);
      r(21801),
        r(40642),
        r(71552),
        r(73796),
        r(97714),
        r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(81172),
        r(31450),
        r(26341),
        r(91597),
        r(86787),
        r(35132),
        r(89623),
        r(84069),
        r(44567),
        r(98380),
        r(92896),
        r(22781),
        r(35197);
      const f = new a.J({
          esriSpatialRelIntersects: 'intersects',
          esriSpatialRelContains: 'contains',
          esriSpatialRelCrosses: 'crosses',
          esriSpatialRelDisjoint: 'disjoint',
          esriSpatialRelEnvelopeIntersects: 'envelope-intersects',
          esriSpatialRelIndexIntersects: 'index-intersects',
          esriSpatialRelOverlaps: 'overlaps',
          esriSpatialRelTouches: 'touches',
          esriSpatialRelWithin: 'within',
          esriSpatialRelRelation: 'relation',
        }),
        g = new a.J({
          esriSRUnit_Meter: 'meters',
          esriSRUnit_Kilometer: 'kilometers',
          esriSRUnit_Foot: 'feet',
          esriSRUnit_StatuteMile: 'miles',
          esriSRUnit_NauticalMile: 'nautical-miles',
          esriSRUnit_USNauticalMile: 'us-nautical-miles',
        });
      let w = (i = class extends l.a {
        constructor(e) {
          super(e),
            (this.cacheHint = void 0),
            (this.distance = void 0),
            (this.geometry = null),
            (this.geometryPrecision = void 0),
            (this.maxAllowableOffset = void 0),
            (this.num = void 0),
            (this.objectIds = null),
            (this.orderByFields = null),
            (this.outFields = null),
            (this.outSpatialReference = null),
            (this.resultType = null),
            (this.returnGeometry = !1),
            (this.returnM = void 0),
            (this.returnZ = void 0),
            (this.start = void 0),
            (this.spatialRelationship = 'intersects'),
            (this.timeExtent = null),
            (this.topFilter = void 0),
            (this.units = null),
            (this.where = '1=1');
        }
        writeStart(e, t) {
          (t.resultOffset = this.start), (t.resultRecordCount = this.num || 10);
        }
        clone() {
          return new i(
            (0, p.d9)({
              cacheHint: this.cacheHint,
              distance: this.distance,
              geometry: this.geometry,
              geometryPrecision: this.geometryPrecision,
              maxAllowableOffset: this.maxAllowableOffset,
              num: this.num,
              objectIds: this.objectIds,
              orderByFields: this.orderByFields,
              outFields: this.outFields,
              outSpatialReference: this.outSpatialReference,
              resultType: this.resultType,
              returnGeometry: this.returnGeometry,
              returnZ: this.returnZ,
              returnM: this.returnM,
              start: this.start,
              spatialRelationship: this.spatialRelationship,
              timeExtent: this.timeExtent,
              topFilter: this.topFilter,
              units: this.units,
              where: this.where,
            }),
          );
        }
      });
      (0, o._)(
        [(0, u.Cb)({ type: Boolean, json: { write: !0 } })],
        w.prototype,
        'cacheHint',
        void 0,
      ),
        (0, o._)(
          [
            (0, u.Cb)({
              type: Number,
              json: { write: { overridePolicy: (e) => ({ enabled: e > 0 }) } },
            }),
          ],
          w.prototype,
          'distance',
          void 0,
        ),
        (0, o._)(
          [(0, u.Cb)({ types: s.qM, json: { read: h.im, write: !0 } })],
          w.prototype,
          'geometry',
          void 0,
        ),
        (0, o._)(
          [(0, u.Cb)({ type: Number, json: { write: !0 } })],
          w.prototype,
          'geometryPrecision',
          void 0,
        ),
        (0, o._)(
          [(0, u.Cb)({ type: Number, json: { write: !0 } })],
          w.prototype,
          'maxAllowableOffset',
          void 0,
        ),
        (0, o._)(
          [(0, u.Cb)({ type: Number, json: { read: { source: 'resultRecordCount' } } })],
          w.prototype,
          'num',
          void 0,
        ),
        (0, o._)([(0, u.Cb)({ json: { write: !0 } })], w.prototype, 'objectIds', void 0),
        (0, o._)(
          [(0, u.Cb)({ type: [String], json: { write: !0 } })],
          w.prototype,
          'orderByFields',
          void 0,
        ),
        (0, o._)(
          [(0, u.Cb)({ type: [String], json: { write: !0 } })],
          w.prototype,
          'outFields',
          void 0,
        ),
        (0, o._)(
          [
            (0, u.Cb)({
              type: b.Z,
              json: { read: { source: 'outSR' }, write: { target: 'outSR' } },
            }),
          ],
          w.prototype,
          'outSpatialReference',
          void 0,
        ),
        (0, o._)(
          [(0, u.Cb)({ type: String, json: { write: !0 } })],
          w.prototype,
          'resultType',
          void 0,
        ),
        (0, o._)([(0, u.Cb)({ json: { write: !0 } })], w.prototype, 'returnGeometry', void 0),
        (0, o._)(
          [
            (0, u.Cb)({
              type: Boolean,
              json: { write: { overridePolicy: (e) => ({ enabled: e }) } },
            }),
          ],
          w.prototype,
          'returnM',
          void 0,
        ),
        (0, o._)(
          [
            (0, u.Cb)({
              type: Boolean,
              json: { write: { overridePolicy: (e) => ({ enabled: e }) } },
            }),
          ],
          w.prototype,
          'returnZ',
          void 0,
        ),
        (0, o._)(
          [(0, u.Cb)({ type: Number, json: { read: { source: 'resultOffset' } } })],
          w.prototype,
          'start',
          void 0,
        ),
        (0, o._)([(0, c.w)('start'), (0, c.w)('num')], w.prototype, 'writeStart', null),
        (0, o._)(
          [
            (0, u.Cb)({
              type: String,
              json: {
                read: { source: 'spatialRel', reader: f.read },
                write: { target: 'spatialRel', writer: f.write },
              },
            }),
          ],
          w.prototype,
          'spatialRelationship',
          void 0,
        ),
        (0, o._)(
          [(0, u.Cb)({ type: n.Z, json: { write: !0 } })],
          w.prototype,
          'timeExtent',
          void 0,
        ),
        (0, o._)([(0, u.Cb)({ type: m.Z, json: { write: !0 } })], w.prototype, 'topFilter', void 0),
        (0, o._)(
          [
            (0, u.Cb)({
              type: String,
              json: {
                read: g.read,
                write: {
                  writer: g.write,
                  overridePolicy(e) {
                    return { enabled: e && this.distance > 0 };
                  },
                },
              },
            }),
          ],
          w.prototype,
          'units',
          void 0,
        ),
        (0, o._)([(0, u.Cb)({ type: String, json: { write: !0 } })], w.prototype, 'where', void 0),
        (w = i = (0, o._)([(0, y.j)('esri.rest.support.TopFeaturesQuery')], w)),
        (w.from = (0, d.e)(w));
      const v = w;
    },
    90549: (e, t, r) => {
      'use strict';
      r.d(t, { Z: () => p });
      var i,
        o = r(29768),
        s = r(74673),
        n = r(34250),
        a = (r(76506), r(91306), r(92143), r(17533));
      r(21972),
        r(23639),
        r(86656),
        r(22723),
        r(91055),
        r(27794),
        r(6906),
        r(50406),
        r(60991),
        r(81172),
        r(71552),
        r(31450),
        r(40642),
        r(26341);
      let l = (i = class extends s.a {
        constructor(e) {
          super(e),
            (this.groupByFields = void 0),
            (this.topCount = void 0),
            (this.orderByFields = void 0);
        }
        clone() {
          return new i({
            groupByFields: this.groupByFields,
            topCount: this.topCount,
            orderByFields: this.orderByFields,
          });
        }
      });
      (0, o._)(
        [(0, n.Cb)({ type: [String], json: { write: !0 } })],
        l.prototype,
        'groupByFields',
        void 0,
      ),
        (0, o._)(
          [(0, n.Cb)({ type: Number, json: { write: !0 } })],
          l.prototype,
          'topCount',
          void 0,
        ),
        (0, o._)(
          [(0, n.Cb)({ type: [String], json: { write: !0 } })],
          l.prototype,
          'orderByFields',
          void 0,
        ),
        (l = i = (0, o._)([(0, a.j)('esri.rest.support.TopFilter')], l));
      const p = l;
    },
  },
]);
